
using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace CWIDatas
{
    public class ContentData : DataWithIO
    {
        #region tB[h
        byte kind;
        string choice;
        uint version;//countƑgݍ킹
        List<ContentData> childList;
        uint makeVersion;//ver.5 only Ro[gÕo[W
        BaseContent contentData;
        #endregion

        #region vpeB
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        public byte Kind
        {
            get { return kind; }
            set { kind = value; }
        }
        public ContentType ContentKind
        {
            get { return (ContentType)kind; }
        }
        public string Choice
        {
            get { return choice; }
            set { choice = value; }
        }
        public List<ContentData> Children
        {
            get
            {
                if (childList == null)
                    childList = new List<ContentData>();
                return childList;
            }
        }
        public BaseContent Data
        {
            get { return contentData; }
        }
        #endregion

        #region [hCg
        public override void Read(BinaryReader r)
        {
            kind = r.ReadByte();
            choice = r.ReadString();
            uint temp = r.ReadUInt32();
            version = temp / CWData.VersionOffset;
            uint count = temp % CWData.VersionOffset;
            ContentData content;
            for (; count > 0; count--)
            {
                content = new ContentData();
                content.Read(r);
                Children.Add(content);
            }
            if (Version == 5)
            {
                makeVersion = r.ReadUInt32();
            }
            contentData = NewContentData();
            contentData.Read(r);
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(kind);
            w.Write(choice);
            w.Write(((uint)Children.Count + version * CWData.VersionOffset));
            foreach (ContentData con in Children)
                con.Write(w);
            if (Version == 5)
            {
                w.Write(makeVersion);
            }
            contentData.Write(w);
        }
        #endregion

        /// <summary>
        /// Reg̎ނɉBaseContent̎qNX̃CX^X𐶐܂B
        /// </summary>
        /// <returns>IuWFNg</returns>
        private BaseContent NewContentData()
        {
            switch (ContentKind)
            {
                case ContentType.AbilityCheck:  //\͔Reg
                    return new AbilityCheckContent();
                case ContentType.ViewChange:  // wiύXReg
                    return new ViewChangeContent();
                case ContentType.Effect:  // ʃReg
                    if (Version == 0)
                    {
                        // ʃRegVersion0̂̂
                        // Version2`EffectData(EffectDataVersionNazo1^Cv)gp
                        return new EffectContent(CWData.DataVersion2);
                    }
                    return new EffectContent(Version);
                case ContentType.Serif:  // ZtReg
                    return new SerifContent();
                case ContentType.Message:  // bZ[WReg
                    return new MessageContent();
                case ContentType.RandomSelect:  // _IReg
                    return new RandomSelectContent();
                case ContentType.ViewPosSize:  // wiʒuETCYύXReg
                    return new ViewPosSizeContent();
                case ContentType.ViewReplace:  // wiuReg
                    return new ViewReplaceContent();
                default:
                    // ̑̃Reg
                    return new BaseContent(ContentKind);
            }
        }

    }//class ContentData
}
