﻿
namespace CWIDatas
{
    /// <summary>
    /// コンテント種別
    /// </summary>
    public enum ContentType : byte
    {
        /// <summary>
        /// スタートコンテント 0x00 (terminal)
        /// </summary>
        Start = 0x00,  
        /// <summary>
        /// スタートリンクコンテント 0x01 (terminal) 
        /// </summary>
        LinkStart = 0x01,  
        /// <summary>
        /// バトルコンテント 0x02 (terminal)
        /// </summary>
        Battle = 0x02,  
        /// <summary>
        /// 終了コンテント 0x03 (terminal) 
        /// </summary>
        End = 0x03,  
        /// <summary>
        /// ゲームオーバーコンテント 0x04 (terminal)
        /// </summary>
        GameOver = 0x04,  
        /// <summary>
        /// エリア移動コンテント 0x05 (terminal) 
        /// </summary>
        ChangeArea = 0x05,  
        /// <summary>
        /// メッセージコンテント 0x06 (standard)
        /// </summary>
        Message = 0x06,  
        /// <summary>
        /// ＢＧＭコンテント 0x07 (standard) 
        /// </summary>
        PlayBgm = 0x07,  
        /// <summary>
        /// 背景変更コンテント 0x08 (standard)
        /// </summary>
        ViewChange = 0x08,  
        /// <summary>
        /// 効果音コンテント 0x09 (standard)
        /// </summary>
        PlaySound = 0x09,  
        /// <summary>
        /// 空白時間コンテント 0x0a (standard) 
        /// </summary>
        Wait = 0x0a,  
        /// <summary>
        /// 効果コンテント 0x0b (standard)
        /// </summary>
        Effect = 0x0b, 
        /// <summary>
        /// メンバ選択コンテント 0x0c (utility) 
        /// </summary>
        MemberSelect = 0x0c,  
        /// <summary>
        /// 能力判定コンテント 0x0d (utility) 
        /// </summary>
        AbilityCheck = 0x0d,  
        /// <summary>
        /// ランダム分岐コンテント 0x0e (utility) 
        /// </summary>
        BranchRandom = 0x0e,  
        /// <summary>
        /// フラグ分岐コンテント 0x0f (data) 
        /// </summary>
        BranchFlag = 0x0f,  
        
        /// <summary>
        /// フラグ変更コンテント 0x10 (data) 
        /// </summary>
        SetFlag = 0x10,  
        /// <summary>
        /// ステップ多岐分岐コンテント 0x11 (data) 
        /// </summary>
        BranchMultiStep = 0x11,  
        /// <summary>
        /// ステップ変更コンテント 0x12 (data) 
        /// </summary>
        SetStep = 0x12,  
        /// <summary>
        /// キャスト分岐コンテント 0x13 (branch) 
        /// </summary>
        BranchCast = 0x13,  
        /// <summary>
        /// アイテム分岐コンテント 0x14 (branch) 
        /// </summary>
        BranchItem = 0x14,  
        /// <summary>
        /// 技能分岐コンテント 0x15 (branch) 
        /// </summary>
        BranchSkill = 0x15,  
        /// <summary>
        /// 情報分岐コンテント 0x16 (branch) 
        /// </summary>
        BranchInfo = 0x16,  
        /// <summary>
        /// 召喚獣分岐コンテント 0x17 (branch) 
        /// </summary>
        BranchBeast = 0x17,  
        /// <summary>
        /// 所持金分岐コンテント 0x18 (branch) 
        /// </summary>
        BranchMoney = 0x18,  
        /// <summary>
        /// クーポン分岐コンテント 0x19 (branch)
        /// </summary>
        BranchCoupon = 0x19,  
        /// <summary>
        /// キャスト加入コンテント 0x1a (get) 
        /// </summary>
        GetCast = 0x1a,  
        /// <summary>
        /// アイテム入手コンテント 0x1b (get) 
        /// </summary>
        GetItem = 0x1b,  
        /// <summary>
        /// 技能入手コンテント 0x1c (get) 
        /// </summary>
        GetSkill = 0x1c,  
        /// <summary>
        /// 情報入手コンテント 0x1d (get) 
        /// </summary>
        GetInfo = 0x1d,  
        /// <summary>
        /// 召喚獣入手コンテント 0x1e (get)
        /// </summary>
        GetBeast = 0x1e,  
        /// <summary>
        /// 所持金増加コンテント 0x1f (get)
        /// </summary>
        GetMoney = 0x1f,  

        /// <summary>
        /// クーポン取得コンテント 0x20 (get) 
        /// </summary>
        GetCoupon = 0x20,  
        /// <summary>
        /// キャスト離脱コンテント 0x21 (lost) 
        /// </summary>
        LostCast = 0x21,  
        /// <summary>
        /// アイテム喪失コンテント 0x22 (lost) 
        /// </summary>
        LostItem = 0x22,  
        /// <summary>
        /// 技能喪失コンテント 0x23 (lost) 
        /// </summary>
        LostSkill = 0x23,  
        /// <summary>
        /// 情報喪失コンテント 0x24 (lost) 
        /// </summary>
        LostInfo = 0x24,  
        /// <summary>
        /// 召喚獣喪失コンテント 0x25 (lost) 
        /// </summary>
        LostBeast = 0x25,  
        /// <summary>
        /// 所持金減少コンテント 0x26 (lost) 
        /// </summary>
        LostMoney = 0x26,  
        /// <summary>
        /// クーポン喪失コンテント 0x27 (lost) 
        /// </summary>
        LostCoupon = 0x27,  
        /// <summary>
        /// セリフコンテント 0x28 (standard)
        /// </summary>
        Serif = 0x28,  
        /// <summary>
        /// ステップ増加コンテント 0x29 (data)
        /// </summary>
        SetStepUp = 0x29,  
        /// <summary>
        /// ステップ減少コンテント 0x2a (data) 
        /// </summary>
        SetStepDown = 0x2a,  
        /// <summary>
        /// フラグ反転コンテント 0x2b (data) 
        /// </summary>
        ReverseFlag = 0x2b,  
        /// <summary>
        /// ステップ上下分岐コンテント 0x2c (data) 
        /// </summary>
        BranchStep = 0x2c,  
        /// <summary>
        /// ターン経過コンテント 0x2d (standard) 
        /// </summary>
        ElapseTime = 0x2d,  
        /// <summary>
        /// レベル判定コンテント 0x2e (utility) 
        /// </summary>
        BranchLevel = 0x2e,  
        /// <summary>
        /// 状態判定コンテント 0x2f (utility)
        /// </summary>
        BranchStatus = 0x2f,  

        /// <summary>
        /// 人数判定コンテント 0x30 (utility) 
        /// </summary>
        BranchPartyNumber = 0x30,  
        /// <summary>
        /// パーティー表示コンテント 0x31 (visual) 
        /// </summary>
        ShowParty = 0x31,  
        /// <summary>
        /// パーティー隠蔽コンテント 0x32 (visual) 
        /// </summary>
        HideParty = 0x32,  
        /// <summary>
        /// 効果中断コンテント 0x33 (terminal) 
        /// </summary>
        EffectBreak = 0x33,  
        /// <summary>
        /// スタートコールコンテント 0x34 (standard)
        /// </summary>
        CallStart = 0x34,  
        /// <summary>
        /// パッケージリンクコンテント 0x35 (terminal) 
        /// </summary>
        LinkPackage = 0x35,  
        /// <summary>
        /// パッケージコールコンテント 0x36 (standard) 
        /// </summary>
        CallPackage = 0x36,  
        /// <summary>
        /// エリア分岐コンテント 0x37 (utility) 
        /// </summary>
        BranchArea = 0x37,  
        /// <summary>
        /// バトル分岐コンテント 0x38 (utility) 
        /// </summary>
        BranchBattle = 0x38,  
        /// <summary>
        /// 終了印分岐コンテント 0x39 (branch) 
        /// </summary>
        BranchStamp = 0x39,  
        /// <summary>
        /// 終了印付加コンテント 0x3a (get) 
        /// </summary>
        GetStamp = 0x3a,  
        /// <summary>
        /// 終了印削除コンテント 0x3b (lost) 
        /// </summary>
        LostStamp = 0x3b,  
        /// <summary>
        /// ゴシップ分岐コンテント 0x3c (branch) 
        /// </summary>
        BranchGossip = 0x3c,  
        /// <summary>
        /// ゴシップ追加コンテント 0x3d (get) 
        /// </summary>
        GetGossip = 0x3d,  
        /// <summary>
        /// ゴシップ削除コンテント 0x3e (lost) 
        /// </summary>
        LostGossip = 0x3e,  
        /// <summary>
        /// バトル判定分岐コンテント 0x3f (utility) 
        /// </summary>
        BranchIsBattle = 0x3f,  

        /// <summary>
        /// 画面再構築コンテント 0x40 (visual) 
        /// </summary>
        ReDisplay = 0x40,  
        /// <summary>
        /// フラグ判定コンテント 0x41 (data) 
        /// </summary>
        CheckFlag = 0x41,  
        /// <summary>
        /// ステップ代入コンテント 0x42 (data) 
        /// </summary>
        SubstituteStep = 0x42,  
        /// <summary>
        /// フラグ代入コンテント 0x43 (data) 
        /// </summary>
        SubstituteFlag = 0x43,  
        /// <summary>
        /// ステップ比較分岐コンテント 0x44 (data) 
        /// </summary>
        BranchStepCmp = 0x44,  
        /// <summary>
        /// フラグ比較分岐コンテント 0x45 (data)
        /// </summary>
        BranchFlagCmp = 0x45,
        /// <summary>
        /// ランダム選択コンテント 0x46 (utility)
        /// </summary>
        RandomSelect = 0x46,
        /// <summary>
        /// キーコード所持分岐コンテント 0x47 (branch)
        /// </summary>
        BranchKeyCode = 0x47,
        /// <summary>
        /// ステップ判定 0x48 (data)
        /// </summary>
        CheckStep = 0x48,
        /// <summary>
        /// ラウンド分岐 0x49 (utility)
        /// </summary>
        BranchRound = 0x49,
        /// <summary>
        /// 背景位置・サイズ変更コンテント 0x4A (standard) 
        /// </summary>
        ViewPosSize = 0x4A,
        /// <summary>
        /// 背景削除コンテント 0x4B (standard) 
        /// </summary>
        ViewDelete = 0x4B,
        /// <summary>
        /// 背景置換コンテント 0x4C (standard) 
        /// </summary>
        ViewReplace = 0x4C

    }
}