﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace CWIDatas
{
    /// <summary>
    /// 背景置換コンテントのデータ
    /// </summary>
    public class ViewReplaceContent : BaseContent
    {
        #region フィールド
        List<CellData> cellList;
        #endregion

        #region プロパティ
        public List<CellData> Cells
        {
            get
            {
                if (cellList == null)
                    cellList = new List<CellData>();
                return cellList;
            }
        }
        #endregion

        public ViewReplaceContent() : base(ContentType.ViewReplace) { }

        #region リードライト
        public override void Read(BinaryReader r)
        {
            // セル名
            str = ((SjisCBinaryReader)r).ReadSmallString();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData cell = new CellData();
                cell.Read(r);
                Cells.Add(cell);
            }
        }
        public override void Write(BinaryWriter w)
        {
            // セル名
            ((SjisCBinaryWriter)w).WriteSmallString(str);
            w.Write(Cells.Count);
            foreach (CellData cell in Cells)
                cell.Write(w);
        }
        #endregion
    }
}

