/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
using System;
using System.IO;
using System.Text;
using System.Collections.Specialized;

namespace CWIDatas
{
    public class SjisCBinaryReader : BinaryReader
    {
        private static Encoding sjisEnc = Encoding.GetEncoding("shift-jis");
        private static char[] CR = { '\r' };
        private static char[] LF = { '\n' };
        public SjisCBinaryReader(Stream output) : base(output, sjisEnc) { ;}
        //J[h[X4byte + NULLI[ɓK
        public override string ReadString()
        {
            int len = ReadInt32();
            byte[] bs = ReadBytes(len - 1);
            if (bs.Length < len - 1)
                throw new EndOfStreamException();
            ReadByte();
            return sjisEnc.GetString(bs);
        }
        public string ReadBytesString(int bytes)
        {
            byte[] bs = ReadBytes(bytes - 1);
            if (bs.Length < bytes - 1)
                throw new EndOfStreamException();
            ReadByte();
            return sjisEnc.GetString(bs);
        }
        //s؂肾stringňf[^p
        public string ReadStringCRLF()
        {
            int len = ReadInt32();
            byte[] bs = ReadBytes(len);
            if (bs.Length < len)
                throw new EndOfStreamException();
            return sjisEnc.GetString(bs);
        }
        //sR[h؂蕶p
        public StringCollection ReadStringCollection()
        {
            int len = ReadInt32();
            if (len == 0)
            {
                return new StringCollection();
            }
            byte[] bs = ReadBytes(len);
            if (bs.Length < len)
                throw new EndOfStreamException();
            string s = sjisEnc.GetString(bs);
            string[] sa = s.Split(LF);
            StringCollection sc = new StringCollection();
            int i, leng = sa.Length - 1;
            for (i = 0; i < leng; i++)
                sc.Add(sa[i].TrimEnd(CR));
            return sc;
        }
        //sR[h؂蕶p(80o[W)
        public StringCollection Read80StringCollection()
        {
            byte len = ReadByte();
            if (len == 0)
            {
                return new StringCollection();
            }

            int totalLen = 0;
            int keta = 1;
            while (len >= 0x80)
            {
                len -= 0x80;

                totalLen += keta * len;
                if (keta == 1)
                {
                    keta = 0x80;
                }
                else
                {
                    keta = keta * 0x100 + 0x80;
                }
                len = ReadByte();
            }
            totalLen += len * keta;

            byte[] bs = ReadBytes(totalLen);
            if (bs.Length < totalLen)
                throw new EndOfStreamException();
            string s = sjisEnc.GetString(bs);
            string[] sa = s.Split(LF);
            StringCollection sc = new StringCollection();
            int i, leng = sa.Length - 1;
            for (i = 0; i < leng; i++)
                sc.Add(sa[i].TrimEnd(CR));
            return sc;
        }
        //Z̖O̕p
        public string ReadSmallString()
        {
            byte len = ReadByte();
            byte[] bs = ReadBytes(len/2);
            if (bs.Length < len/2)
                throw new EndOfStreamException();
            return sjisEnc.GetString(bs);
        }
        public string ReadByteString()
        {
            byte len = ReadByte();
            byte[] bs = ReadBytes(len);
            if (bs.Length < len)
                throw new EndOfStreamException();
            return sjisEnc.GetString(bs);
        }
        //80UInt32p
        public uint Read80UInt32()
        {
            byte len = ReadByte();
            uint totalLen = 0;
            uint keta = 1;
            while (len >= 0x80)
            {
                len -= 0x80;

                totalLen += keta * len;
                if (keta == 1)
                {
                    keta = 0x80;
                }
                else
                {
                    keta = keta * 0x100 + 0x80;
                }
                len = ReadByte();
            }
            totalLen += len * keta;
            return totalLen;
        }
    }
}
