using System;
using System.IO;
using System.Collections.Specialized;

namespace CWIDatas
{
    /// <summary>
    /// Z摜P̃f[^B
    /// GAƔwiύXRegŎgB
    /// </summary>
    public class CellData : DataWithIO
    {
        #region tB[h
        int left;
        int top;
        uint widthANDversion;
        uint height;
        string file;
        byte mask;
        string flag;
        byte visible;
        #endregion

        #region vpeB
        /// <summary>
        /// f[^o[W
        /// </summary>
        public uint Version
        {
            get { return widthANDversion / CWData.VersionOffset; }
            set { widthANDversion = (uint)Width + value * CWData.VersionOffset; }
        }
        public int Left
        {
            get { return left; }
            set { left = value; }
        }
        public int Top
        {
            get { return top; }
            set { top = value; }
        }
        public int Width
        {
            get { return (int)(widthANDversion % CWData.VersionOffset); }
            set { widthANDversion = (uint)value + Version * CWData.VersionOffset; }
        }
        public int Height
        {
            get { return (int)height; }
            set { height = (uint)value; }
        }
        /// <summary>
        /// Z摜̃t@C
        /// </summary>
        public string FileName
        {
            get { return file; }
            set { file = value; }
        }
        /// <summary>
        /// }XNL
        /// </summary>
        public bool MaskOn
        {
            get { return !(mask == 0); }
            set { mask = (byte)(value ? 1 : 0); }
        }
        /// <summary>
        /// }XN
        /// </summary>
        public byte Mask
        {
            get { return mask; }
            set { mask = value; }
        }
        /// <summary>
        /// QƃtO
        /// </summary>
        public string FlagName
        {
            get { return flag; }
            set { flag = value; }
        }
        /// <summary>
        /// ԂǂB{tOŐ䂵vC[͒ڕύXłȂB
        /// </summary>
        public bool Visible
        {
            get { return !(visible == 0); }
            set { visible = (byte)(value ? 1 : 0); }
        }
        /// <summary>
        /// gZ^Cv
        /// TextCell:0x02,ColorCell:0x03
        /// </summary>
        public byte ExtCellType = 0x02;
        /// <summary>
        /// \eLXg
        /// </summary>
        public StringCollection DispText;
        /// <summary>
        /// tHg
        /// </summary>
        public string FontName = "lr ";
        /// <summary>
        /// tHgTCY
        /// </summary>
        public uint FontSize = 24;
        /// <summary>
        /// `qfa
        /// </summary>
        public uint Argb = 0xFFFFFFFF;
        /// <summary>
        /// tHg
        /// </summary>
        public byte DecoFont = 0x00;
        /// <summary>
        /// ^Cv
        /// </summary>
        public byte NakaType = 0x00;
        /// <summary>
        /// tHgJ[
        /// </summary>
        public uint NakaColor = 0xFFFFFFFF;
        /// <summary>
        /// tHgTCY
        /// </summary>
        public uint NakaSize = 0x00;
        /// <summary>
        /// \axsd
        /// </summary>
        public byte YoyakuByte = 0x00;
        /// <summary>
        /// Of[V
        /// </summary>
        public byte Gradation = 0x00;
        /// <summary>
        /// `qfak
        /// </summary>
        public uint ArgbLower = 0x00;

        /// <summary>
        /// vC[m
        /// </summary>
        public byte PlayerNo = 0x01;

        /// <summary>
        /// J[hOʂ
        /// 01:OʁA00:w 
        /// </summary>
        public byte CardFront = 0x00;

        /// <summary>
        /// Z̖O
        /// </summary>
        public string CellName = null;
        #endregion

        #region [hCg
        public override void Read(BinaryReader r)
        {
            left = r.ReadInt32();
            top = r.ReadInt32();
            widthANDversion = r.ReadUInt32();
            height = r.ReadUInt32();

            if (Version < 6)
            {
                file = r.ReadString();
            }
            else
            {
                ExtCellType = r.ReadByte();
            }

            mask = r.ReadByte();

            if (Version >= 6)
            {
                if (Version == 7)
                {
                    CardFront = r.ReadByte();
                }

                if (ExtCellType == 0x02)
                {
                    // eLXgZ
                    DispText = ((SjisCBinaryReader)r).ReadStringCollection();
                    FontName = r.ReadString();
                    FontSize = r.ReadUInt32();
                    Argb = r.ReadUInt32();
                    DecoFont = r.ReadByte();
                    NakaType = r.ReadByte();
                    NakaColor = r.ReadUInt32();
                    NakaSize = r.ReadUInt32();
                    YoyakuByte = r.ReadByte();
                }
                else if (ExtCellType == 0x03)
                {
                    // J[Z
                    Gradation = r.ReadByte();
                    Argb = r.ReadUInt32();
                    if (Gradation != 0x00)
                    {
                        // PFȊO
                        ArgbLower = r.ReadUInt32();
                    }
                }
                else if (ExtCellType == 0x04)
                {
                    // obZ
                    PlayerNo = r.ReadByte();
                }
            }

            if (Version > 0)
            {
                flag = r.ReadString();
                visible = r.ReadByte();
            }

            if (Version == 7)
            {
                CellName = ((SjisCBinaryReader)r).ReadSmallString();
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(left);
            w.Write(top);
            w.Write(widthANDversion);
            w.Write(height);

            if (Version < 6)
            {
                w.Write(file);
            }
            else
            {
                w.Write(ExtCellType);
            }
            w.Write(mask);

            if (Version >= 6)
            {
                if (Version == 7)
                {
                    w.Write(CardFront);
                }

                if (ExtCellType == 0x02)
                {
                    // eLXgZ
                    ((SjisCBinaryWriter)w).Write(DispText);
                    w.Write(FontName);
                    w.Write(FontSize);
                    w.Write(Argb);
                    w.Write(DecoFont);
                    w.Write(NakaType);
                    w.Write(NakaColor);
                    w.Write(NakaSize);
                    w.Write(YoyakuByte);
                }
                else if (ExtCellType == 0x03)
                {
                    // J[Z
                    w.Write(Gradation);
                    w.Write(Argb);
                    if (Gradation != 0x00)
                    {
                        // PFȊO
                        w.Write(ArgbLower);
                    }
                }
                else if (ExtCellType == 0x04)
                {
                    // obZ
                    w.Write(PlayerNo);
                }
            }

            if (Version > 0)
            {
                w.Write(flag);
                w.Write(visible);
            }

            if (Version == 7)
            {
                ((SjisCBinaryWriter)w).WriteSmallString(CellName);
            }

        }
        #endregion

        #region ftHgl
        public void SetDefault()
        {
            this.Left = 0;
            this.Top = 0;
            this.Version = 5;
            this.Width = 632;
            this.Height = 420;
            this.MaskOn = false;
            this.FlagName = null;
            this.Visible = true;
        }
        #endregion
    }//class CellData
}
