
using System;
using System.IO;

namespace CWIDatas
{

    /// <summary>
    /// ʃf[^B
    /// ʃRegALJ[hȂǂɗpB
    /// </summary>
    public class EffectData : DataWithIO
    {
        public enum ʃ^u : byte
        {
            , , Z\, _, @, \, , J[h, 
        }
        public enum  : byte
        {
            S, , _, _, , , C
        }
        public enum l̎ : byte
        {
            x, , ől
        }

        public enum  : byte
        {
            , _[W, z
        }
        //񕜁E_EzA
        public enum  : byte
        {
            , ჉, , ŉ
        }
        //ჁEEŁEŉA
        public enum Z\ : byte
        {
            _͉, _͑r
        }
        //EA
        public enum _ : byte
        {
            , , V, E, Q,  
        }
        //EEVEEEQ[A
        public enum @ : byte
        {
            , , , ى, \I, \I, , 
        }
        //EEفEE\IE\EE
        public enum \ : byte
        {
            s͕ω, ͕ω, h͕ω, R͕ω
        }
        //sρEρEhρER
        public enum  : byte
        {
            Ώ, D, b
        }
        //ΏہEDE
        public enum J[h : byte
        {
            U, Ӑg̈ꌂ, S̈ꌂ, tFCg, h, ؂, , Z\
        }
        //UEӐgESEtFEhE؁EE
        public enum  : byte
        {
            b
        }
        //

        #region tB[h
        byte tabNumber;
        byte nazo1_8;
        uint version;
        byte attribute;
        byte effectNumber;
        byte valueKind;//0:x 1: 2:ől
        uint round;
        int val;
        WidCard beast;
        #endregion

        #region vpeB
        /// <summary>
        /// ʂ̎ނ̕ނ\^ułB
        /// </summary>
        public ʃ^u EffectTab
        {
            get { return (ʃ^u)tabNumber; }
            set { tabNumber = (byte)value; }
        }
        /// <summary>
        /// f[^o[W
        /// </summary>
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        /// <summary>
        /// eʂ̑Fex)_, 
        /// </summary>
        public  Attribute
        {
            get { return ()attribute; }
            set { attribute = (byte)value; }
        }
        /// <summary>
        /// ʃ^uō牽Ԗڂ̌ʂB
        /// ܂^uԍƕČʂ̎ނ肵܂B
        /// </summary>
        public byte EffectNumberInTab
        {
            get { return effectNumber; }
            set { effectNumber = value; }
        }
        /// <summary>
        /// _[WʂȂǂł̃xAڂȂǂ\܂B
        /// </summary>
        public l̎ ValueKind
        {
            get { return (l̎)valueKind; }
            set { valueKind = (byte)value; }
        }
        /// <summary>
        /// @␸_ʂȂǂł́ApEh\܂B
        /// </summary>
        public uint Round
        {
            get { return round; }
            set
            {
                if (value > CWData.MaxEffectRound) round = CWData.MaxEffectRound;
                else round = value;
            }
        }
        /// <summary>
        /// eʂŌʂ̑傫\lłB
        /// \͕ω̋xMagicValueg܂B
        /// ܂pEhRoundg܂B
        /// błȌꍇAbȂ\܂
        /// </summary>
        public uint Value
        {
            get { return (uint)val; }
            set
            {
                if (value > CWData.MaxEffectValue) val = (int)CWData.MaxEffectValue;
                else if (value <= 0) val = 1;
                else val = (int)value;
            }
        }
        /// <summary>
        /// \͕ω̋x
        /// </summary>
        public int MagicValue
        {
            get { return val; }
            set
            {
                if (value > CWData.MaxModifyMount) val = CWData.MaxModifyMount;
                else if (value < CWData.MinModifyMount) val = CWData.MinModifyMount;
                else val = value;
            }
        }
        /// <summary>
        /// bf[^B蓖Ă͍sȂ
        /// </summary>
        public WidCard Beast
        {
            get { return beast; }
            set
            {
                beast = value;
                if (beast != null)
                    val = 1;
                else
                    val = 0;
            }
        }
        #endregion

        #region RXgN^
        /// <summary>
        /// ʏRXgN^(Version3ȏversion擾ł̂łłOK)
        /// </summary>
        public EffectData()
        {

        }

        /// <summary>
        /// RXgN^(Version2p:Version2versiont@C̒ɎȂ̂Őݒ肵ĂB)
        /// </summary>
        /// <param name="version"></param>
        public EffectData(uint version)
        {
            this.version = version;
        }
        #endregion

        #region [hCg
        public override void Read(BinaryReader r)
        {
            //^uCfbNX
            tabNumber = r.ReadByte();

            if (version > CWData.DataVersion2)
            {
                nazo1_8 = r.ReadByte();
                version = r.ReadUInt32();
            }

            //
            attribute = r.ReadByte();
            if (tabNumber == 8)
            {//b͕ʍ\
                val = r.ReadInt32();
                if (val == 0)
                    return;
                beast = new WidCard(WidIDtype.b);
                beast.Read(r);
                return;
            }

            //ʃ^u̒̌ʎʂ̃CfbNX
            effectNumber = r.ReadByte();
            switch (tabNumber)
            {
                case 0://
                case 1://
                    valueKind = r.ReadByte();
                    val = r.ReadInt32();
                    break;
                case 2://Z\
                    break;
                case 3://_
                case 4://@
                    if (version > CWData.DataVersion2)
                    {
                        // ׳ނ̊TOVersion2ɂ͂Ȃ
                        round = r.ReadUInt32();
                    }
                    break;
                case 5://\
                    val = r.ReadInt32();
                    if (version > CWData.DataVersion2)
                    {
                        // ׳ނ̊TOVersion2ɂ͂Ȃ
                        round = r.ReadUInt32();
                    }
                    break;
                case 6://
                case 7://J[h
                    break;
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(tabNumber);

            if (Version > CWData.DataVersion2)
            {
                w.Write(nazo1_8);
                w.Write(version);
            }
            
            w.Write(attribute);
            if (tabNumber == 8)
            {//b͕ʍ\
                w.Write(val);
                if (val == 0)
                    return;
                beast.Write(w);
                return;
            }
            w.Write(effectNumber);
            switch (tabNumber)
            {
                case 0://
                case 1://
                    w.Write(valueKind);
                    w.Write(val);
                    break;
                case 2://Z\
                    break;
                case 3://_
                case 4://@
                    if (version > CWData.DataVersion2)
                    {
                        // ׳ނ̊TOVersion2ɂ͂Ȃ
                        w.Write(round);
                    }
                    break;
                case 5://\
                    w.Write(val);
                    if (version > CWData.DataVersion2)
                    {
                        // ׳ނ̊TOVersion2ɂ͂Ȃ
                        w.Write(round);
                    }
                    break;
                case 6://
                case 7://J[h
                    break;
            }
        }
        #endregion

    }//class EffectData
}
