/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
/**
 * ViIsf[^
 */
using System;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace CWIDatas
{

    public class ScenarioData : DataWithIO
    {
        #region tB[h
        short nazo1_0;
        string folderpath;
        uint areaNumber;
        StringCollection stepValueStringList;
        StringCollection flagValueStringList;
        StringCollection npcCardStringList;
        StringCollection infoCardStringList;
        string bgmFilename;
        List<CellData> cellList;
        #endregion

        #region vpeB
        public string ScenarioFolder
        {
            get { return folderpath; }
            set { folderpath = value; }
        }
        public uint AreaNumber
        {
            get { return areaNumber; }
            set { areaNumber = value; }
        }
        public StringCollection StepValues
        {
            get
            {
                if (stepValueStringList == null)
                    stepValueStringList = new StringCollection();
                return stepValueStringList;
            }
            set
            {
                stepValueStringList = value;
            }
        }
        public StringCollection FlagValues
        {
            get
            {
                if (flagValueStringList == null)
                    flagValueStringList = new StringCollection();
                return flagValueStringList;
            }
            set
            {
                flagValueStringList = value;
            }
        }
        public StringCollection PossessNpcCards
        {
            get
            {
                if (npcCardStringList == null)
                    npcCardStringList = new StringCollection();
                return npcCardStringList;
            }
            set
            {
                npcCardStringList = value;
            }
        }
        public StringCollection PossessInfoCards
        {
            get
            {
                if (infoCardStringList == null)
                    infoCardStringList = new StringCollection();
                return infoCardStringList;
            }
            set
            {
                infoCardStringList = value;
            }
        }
        public string BGMFile
        {
            get { return bgmFilename; }
            set { bgmFilename = value; }
        }
        public List<CellData> Cells
        {
            get
            {
                if (cellList == null)
                    cellList = new List<CellData>();
                return cellList;
            }
            set
            {
                if (value != null)
                    cellList = value;
            }
        }
        #endregion

        #region [hCg
        public override void Read(System.IO.BinaryReader r)
        {
            nazo1_0 = r.ReadInt16();
            folderpath = r.ReadString();
            areaNumber = r.ReadUInt32();
            stepValueStringList = ((SjisCBinaryReader)r).ReadStringCollection();
            flagValueStringList = ((SjisCBinaryReader)r).ReadStringCollection();
            npcCardStringList = ((SjisCBinaryReader)r).ReadStringCollection();
            infoCardStringList = ((SjisCBinaryReader)r).ReadStringCollection();
            bgmFilename = r.ReadString();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData d = new CellData();
                d.Read(r);
                Cells.Add(d);
            }
        }
        public override void Write(System.IO.BinaryWriter w)
        {
            w.Write(nazo1_0);
            w.Write(folderpath);
            w.Write(areaNumber);
            ((SjisCBinaryWriter)w).Write(StepValues);
            ((SjisCBinaryWriter)w).Write(FlagValues);
            ((SjisCBinaryWriter)w).Write(PossessNpcCards);
            ((SjisCBinaryWriter)w).Write(PossessInfoCards);
            w.Write(bgmFilename);
            w.Write(Cells.Count);
            foreach (CellData d in Cells)
                d.Write(w);
        }
        #endregion

        #region \bh
        public void SetStep(string name, int value)
        {
            for (int i = 0; i < this.StepValues.Count;i++ )
            {
                if (this.StepValues[i].Split('=')[0].Equals(name))
                {
                    this.StepValues[i]
                        = name + "=" + value;
                    return;
                }
            }

            this.StepValues.Add(name + "=" + value);
        }

        public void AddStep(string name)
        {
            for (int i = 0; i < this.StepValues.Count; i++)
            {
                string[] str = this.StepValues[i].Split('=');
                if (str[0].Equals(name))
                {
                    int value = int.Parse(str[1]);
                    this.StepValues[i]
                        = name + "=" + ((value + 1 == 10) ? 9 : (value + 1));
                    return;
                }
            }

            this.StepValues.Add(name + "=" + 0);
        }

        public void SetFlag(string name, int value)
        {
            for (int i = 0; i < this.FlagValues.Count;i++ )
            {
                if (this.FlagValues[i].Split('=')[0].Equals(name))
                {
                    this.FlagValues[i]
                        = name + "=" + value;
                    return;
                }
            }

            this.FlagValues.Add(name + "=" + value);
        }

        public void SetInfo(string name)
        {

            foreach (string str in this.PossessInfoCards)
            {
                if (str.Equals(name))
                {
                    return;
                }
            }

            this.PossessInfoCards.Add(name);
        }
        #endregion

    }//class ScenarioData
}
