/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.Collections.Generic;
using System.IO;

namespace CWIDatas
{

    public class WidArea : DataWithIO
    {
        #region tB[h
        byte widid;
        ImageData nullImage;
        string name;
        uint numberANDversion;
        List<EventData> eventList;
        byte custom;
        List<MenuData> menuList;
        List<CellData> cellList;
        #endregion

        #region vpeB
        /// <summary>
        /// GAVersion2̏ꍇɒlႤ
        /// </summary>
        public WidIDtype WidID
        {
            get { return (WidIDtype)widid; }
        }
        public ImageData Image
        {
            get { return nullImage; }
        }
        /// <summary>
        /// GA̖O
        /// </summary>
        public string AreaName
        {
            get { return name; }
            set { name = value; }
        }
        public uint Version
        {
            get { return numberANDversion / CWData.VersionOffset; }
            set { numberANDversion = FileNumber + value * CWData.VersionOffset; }
        }
        /// <summary>
        /// GAԍ
        /// </summary>
        public uint FileNumber
        {
            get { return numberANDversion % CWData.VersionOffset; }
            set { numberANDversion = value + Version * CWData.VersionOffset; }
        }
        public List<EventData> Events
        {
            get
            {
                if (eventList == null)
                    eventList = new List<EventData>();
                return eventList;
            }
        }
        /// <summary>
        /// J[hʒu蓮ݒ肪true, łfalse
        /// </summary>
        public bool CustomCardPosition
        {
            get { return !(custom == 0); }
            set { custom = (byte)(value ? 1 : 0); }
        }
        public List<MenuData> Menus
        {
            get
            {
                if (menuList == null)
                    menuList = new List<MenuData>();
                return menuList;
            }
        }
        public List<CellData> Cells
        {
            get
            {
                if (cellList == null)
                    cellList = new List<CellData>();
                return cellList;
            }
        }
        #endregion

        public WidArea() { nullImage = new ImageData(); }

        #region [hCg
        public override void Read(BinaryReader r)
        {
            widid = r.ReadByte();
            nullImage.Read(r);
            name = r.ReadString();
            numberANDversion = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            custom = r.ReadByte();
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                MenuData mn = new MenuData();
                mn.Read(r);
                Menus.Add(mn);
            }
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData cl = new CellData();
                cl.Read(r);
                Cells.Add(cl);
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(widid);
            nullImage.Write(w);
            w.Write(name);
            w.Write(numberANDversion);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(custom);
            w.Write(Menus.Count);
            foreach (MenuData mn in Menus)
                mn.Write(w);
            w.Write(Cells.Count);
            foreach (CellData cl in Cells)
                cl.Write(w);
        }
        #endregion

        #region \bh
        /// <summary>
        /// L[R[h
        /// </summary>
        /// <param name="txt"></param>
        /// <returns></returns>
        public bool KeyCodeIsIncluded(string txt)
        {
            foreach (EventData ev in this.Events)
            {
                foreach (string keyCode in ev.KeyCodes)
                {
                    if (keyCode.Contains(txt)) return true;
                }
            }

            foreach (MenuData menu in Menus)
            {
                foreach (EventData ev in menu.Events)
                {
                    foreach (string keyCode in ev.KeyCodes)
                    {
                        if (keyCode.Contains(txt)) return true;
                    }
                }
            }
            return false;
        }

        /// <summary>
        /// L[R[hOv
        /// </summary>
        /// <param name="txt"></param>
        /// <returns></returns>
        public bool KeyCodeStartsWith(string txt)
        {
            foreach (EventData ev in this.Events)
            {
                foreach (string keyCode in ev.KeyCodes)
                {
                    if (keyCode.StartsWith(txt)) return true;
                }
            }

            foreach (MenuData menu in Menus)
            {
                foreach (EventData ev in menu.Events)
                {
                    foreach (string keyCode in ev.KeyCodes)
                    {
                        if (keyCode.StartsWith(txt)) return true;
                    }
                }
            }
            return false;
        }

        /// <summary>
        /// N[|
        /// </summary>
        /// <param name="txt"></param>
        /// <returns></returns>
        public string CouponIsIncluded(string txt)
        {
            string ret;
            foreach (EventData ev in this.Events)
            {
                foreach (ContentData start in ev.Starts)
                {
                    ret = CheckCoupon(start.Children, start.Choice, txt);
                    if (ret != null) return ret;
                }
            }

            foreach (MenuData menu in Menus)
            {
                foreach (EventData ev in menu.Events)
                {
                    foreach (ContentData start in ev.Starts)
                    {
                        ret = CheckCoupon(start.Children, start.Choice, txt);
                        if (ret != null) return ret;
                    }
                }
            }

            return null;
        }

        private string CheckCoupon(List<ContentData> contents, string startText, string txt)
        {
            foreach (ContentData content in contents)
            {
                if (content.ContentKind == ContentType.GetCoupon ||
                    content.ContentKind == ContentType.LostCoupon ||
                    content.ContentKind == ContentType.BranchCoupon)
                {
                    if (content.Data.StringData == txt)
                    {
                        return startText + ":" + content.ContentKind.ToString();
                    }
                }

                if(content.Children.Count == 0) continue;

                string ret = CheckCoupon(content.Children, startText, txt);
                if (ret != null) return ret;
            }

            return null;
        }

        /// <summary>
        /// SVbv
        /// </summary>
        /// <param name="txt"></param>
        /// <returns></returns>
        public string GossipIsIncluded(string txt)
        {
            string ret;
            foreach (EventData ev in this.Events)
            {
                foreach (ContentData start in ev.Starts)
                {
                    ret = CheckGossip(start.Children, start.Choice, txt);
                    if (ret != null) return ret;
                }
            }

            foreach (MenuData menu in Menus)
            {
                foreach (EventData ev in menu.Events)
                {
                    foreach (ContentData start in ev.Starts)
                    {
                        ret = CheckGossip(start.Children, start.Choice, txt);
                        if (ret != null) return ret;
                    }
                }
            }

            return null;
        }

        private string CheckGossip(List<ContentData> contents, string startText, string txt)
        {
            foreach (ContentData content in contents)
            {
                if (content.ContentKind == ContentType.GetGossip ||
                    content.ContentKind == ContentType.LostGossip ||
                    content.ContentKind == ContentType.BranchGossip)
                {
                    if (content.Data.StringData == txt)
                    {
                        return startText + ":" + content.ContentKind.ToString();
                    }
                }

                if (content.Children.Count == 0) continue;

                string ret = CheckGossip(content.Children, startText, txt);
                if (ret != null) return ret;
            }

            return null;
        }
        #endregion
    }
    //class WidArea
}
