﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.IO;
using CWIDatas;
using CWI.Dialog;

namespace CWI
{
    /// <summary>
    /// 宿フォルダ内のパーティ.wplファイル。
    /// パーティーデータからきちんと読み出せていれば
    /// すぐに必要なのはMember名だけ？
    /// </summary>
    public class PartyIndexData : DataWithIO
    {
        #region フィールド
        short nazo0;
        string scenario;
        ImageData image;
        StringCollection memberNameList;
        string partyName;
        uint money;
        byte inScenario;
        #endregion

        #region プロパティ
        /// <summary>
        /// 進行中のシナリオ名 or 宿の名前
        /// </summary>
        public string PlayingScenarioName
        {
            get { return scenario; }
            set { scenario = value; }
        }
        /// <summary>
        /// 進行中シナリオイメージ or 宿イメージ
        /// </summary>
        public ImageData ScenarioImage
        {
            get { return image; }
            set { image = value; }
        }
        /// <summary>
        /// パーティのメンバー
        /// </summary>
        public StringCollection Members
        {
            get
            {
                if (memberNameList == null)
                    memberNameList = new StringCollection();
                return memberNameList;
            }
        }
        public string PartyName
        {
            get { return partyName; }
            set { partyName = value; }
        }
        /// <summary>
        /// 所持金
        /// </summary>
        public uint Money
        {
            get { return money; }
            set { money = value; }
        }
        public bool InScenario
        {
            get { return (inScenario == 1); }
            set { inScenario = (byte)(value ? 1 : 0); }
        }
        #endregion

        #region 追加プロパティ
        /// <summary>
        /// 正確なフルパスのファイル名
        /// </summary>
        string fileName = string.Empty;
        public string FileName
        {
            get
            {
                return fileName;
            }
            set
            {
                fileName = value;
            }
        }
        #endregion

        #region コンストラクタ
        public PartyIndexData() { image = new ImageData(); }

        #endregion

        #region リードライト
        public override void Read(System.IO.BinaryReader r)
        {
            nazo0 = r.ReadInt16();
            scenario = r.ReadString();            
            image.Read(r);
            memberNameList = ((SjisCBinaryReader)r).ReadStringCollection();
            
            partyName = r.ReadString();
            money = r.ReadUInt32();   
            inScenario = r.ReadByte();
        }
        public override void Write(System.IO.BinaryWriter w)
        {
            w.Write(nazo0);
            w.Write(scenario);
            image.Write(w);
            ((SjisCBinaryWriter)w).Write(Members);
            w.Write(partyName);
            w.Write(money);
            w.Write(inScenario);
        }
        #endregion

    }//class PartyIndexData

}
