using System;
using System.IO;
using System.Drawing;
using System.Collections.Specialized;
using CWIDatas;
using System.Resources;

namespace CWI
{
    public class YadoSelectData : DataWithIO
    {
        #region vpeB
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
        string name;
        public string Folder
        {
            get
            {
                return folder;
            }
            set
            {
                folder = value;
            }
        }
        string folder;
        public string TempFolder
        {
            get
            {
                return FilePath.GetYadoTempFolder(name);
            }
        }

        public bool IsDebugYado
        {
            get
            {
                return (game_or_debug == 2);
            }
            set
            {
                if (value)
                {
                    game_or_debug = 2;
                    img = debugYadoImg;
                }
                else
                {
                    game_or_debug = 1;
                    img = gameYadoImg;
                }
            }
        }
        byte game_or_debug = 1;

        public StringCollection Members 
        {
            get
            {
                return memberNameList;
            }
            set
            {
                memberNameList = value;
            }
        }
        StringCollection memberNameList = null;

        public Bitmap Img
        {
            get
            {
                if (IsDebugYado)
                {
                    img = debugYadoImg;
                }
                else
                {
                    img = gameYadoImg;
                }
                return img;
            }
            set
            {
                img = value;
            }
        }
        Bitmap img = null;

        
        public string FileName
        {
            get { return filename; }
            set { filename = value; }
        }
        private string filename;

        public DateTime LastAccessTime
        {
            get { return lastAccessTime; }
            set { lastAccessTime = value; }
        }
        private DateTime lastAccessTime;
        #endregion

        #region static
        private static Bitmap debugYadoImg;
        private static Bitmap gameYadoImg;

        static YadoSelectData()
        {
            debugYadoImg = CWIEngine.Properties.Resources.CardMenu_foOh;
            debugYadoImg.MakeTransparent(debugYadoImg.GetPixel(0, 0));
            gameYadoImg = CWIEngine.Properties.Resources.CardMenu_Ŕ;
            gameYadoImg.MakeTransparent(gameYadoImg.GetPixel(0, 0));
        }
        #endregion

        #region RXgN^

        public YadoSelectData() { }

        public YadoSelectData(string folderPath)
        {
            try
            {
                this.Folder = folderPath;
                this.Name = FilePath.FileNameFromPath(folderPath);

                // o[
                this.Members = new StringCollection();

                // p[eB[o[
                PartyIndexDataMembers pidm;
                string[] strArray;
                string[] partyFiles
                    = Directory.GetFiles(Folder, FilePath.MaskIndexPartyData);
                foreach (string file in partyFiles)
                {
                    try
                    {
                        pidm = new PartyIndexDataMembers(file);

                        strArray = new string[pidm.Members.Count];
                        pidm.Members.CopyTo(strArray, 0);

                        Members.AddRange(strArray);
                    }
                    catch (Exception)
                    {
                        //PartyMaker.CWIErrorMessage("p[eB[̓ǂݍ݂ɎsF" + ex.Message);
                    }
                }

                // ҋ@ob
                CharacterName cn;
                string[] charaFiles 
                    = Directory.GetFiles(Folder, FilePath.MaskIndexCharacterData);
                foreach (string file in charaFiles)
                {
                    cn = new CharacterName(file);
                    Members.Add(cn.Name);
                }

                this.Read(FilePath.GetYadoEnvironmentFile(folder));


                FileInfo fi = new FileInfo(this.Folder);
                this.LastAccessTime = fi.LastAccessTime;

            }
            catch (Exception ex)
            {
                PartyMaker.CWIErrorMessage("h̓ǂݍ݂ɎsF" + ex.Message);
            }
        }

        #endregion

        #region [hCg

        public override void Read(string file)
        {
            FileName = file;
            base.Read(file);
        }

        public override void Read(System.IO.BinaryReader r)
        {
            Stream stream = r.BaseStream;

            //versionString
            //versionString = r.ReadString();
            int size = r.ReadInt32();
            if (size != 0) stream.Seek(size, SeekOrigin.Current);
            
            game_or_debug = r.ReadByte();

        }
        public override void Write(System.IO.BinaryWriter w)
        {
        }
        #endregion
    }
}
