﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

using CWIDatas;
using CWI.Card;
using CWI;

namespace CWI.Dialog
{
    public partial class CouponStringDlg : Form
    {
        #region メンバ
        public String SelectedText;
        private Form _owner;
        private PCソート種類 sortType;
        #endregion

        #region コンストラクタ

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public CouponStringDlg()
        {
            // 通常使用しない
            InitializeComponent();
        }

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public CouponStringDlg(Form owner,PCソート種類 sortType)
        {
            InitializeComponent();

            this._owner = owner;
            this.sortType = sortType;
            this.StartPosition = FormStartPosition.Manual;
            this.Left =
            _owner.Left + (_owner.Width - this.Width) / 2;
            this.Top =
                _owner.Top + (_owner.Height - this.Height) / 2;

        }

        #endregion

        #region フォーム

        /// <summary>
        /// フォームロード
        /// </summary>
        private void CouponStringDlg_Load(object sender, EventArgs e)
        {
            if (sortType == PCソート種類.クーポン)
            {
                this.Text = "クーポン名（の一部）を入力してください。";
            }
            else
            {
                this.Text = "カード名（の一部）を入力してください。";
            }
        }

        /// <summary>
        /// フォーム表示時
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CouponStringDlg_Shown(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// 閉じるボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEnd_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        /// <summary>
        /// フォームが閉じられる時のイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CouponStringDlg_FormClosing(object sender, FormClosingEventArgs e)
        {

        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            this.SelectedText = this.txtCoupon.Text;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }
        #endregion

    }
}