﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

using CWIDatas;
using CWI.Card;
using CWI;

namespace CWI.Dialog
{
    public partial class ExpressionDlg : Form
    {
        #region メンバ

        private Form _owner;
        private CharacterData chara = null;
        private WidCard data = null;
        private CharacterData makeChara = null;
        #endregion

        #region コンストラクタ

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public ExpressionDlg()
        {
            // 通常使用しない
            InitializeComponent();
        }

        private void SetPosition(Form owner)
        {
            _owner = owner;
            this.StartPosition = FormStartPosition.Manual;
            this.Left =
            _owner.Left + (_owner.Width - this.Width) / 2;
            this.Top =
                _owner.Top + (_owner.Height - this.Height) / 2;
        }

        /// <summary>
        /// コンストラクタ
        /// (paramOption = True 時、身体特性＋精神特性の閲覧)
        /// (paramOption = False 時、標準型の説明)
        /// </summary>
        public ExpressionDlg(CharacterDlg owner, bool paramOption)
        {

            InitializeComponent();


            if (paramOption)
            {

                owner.SetNewCharacter();
                this.makeChara = owner.Cha;
                this.Text = "適性";

                //418まで広げる
                this.Width += 18;
                this.dgvCharacter.Width += 18;
            }

            SetPosition(owner);

        }

        /// <summary>
        /// コンストラクタ
        /// (既成PCの身体特性＋精神特性の閲覧)
        /// </summary>
        public ExpressionDlg(Form owner, CharacterData cd)
        {
            InitializeComponent();
            this.makeChara = cd;
            this.Text = "適性";

            //418まで広げる
            this.Width += 18;
            this.dgvCharacter.Width += 18;

            SetPosition(owner);

        }

        /// <summary>
        /// コンストラクタ
        /// (効果情報)
        /// </summary>
        public ExpressionDlg(Form owner,CharacterData cd, WidCard wc)
        {
            InitializeComponent();

            SetPosition(owner);

            this.chara = cd;
            this.data = wc;

            this.Text = "効果一覧";

        }

        #endregion

        #region フォーム

        /// <summary>
        /// フォームロード
        /// </summary>
        private void ExpressionDlg_Load(object sender, EventArgs e)
        {
            if (chara == null || data == null)
            {
                // 標準型の説明　か　身体特性＋精神特性
                if (makeChara == null)
                {
                    // 標準型の説明
                    lblNormal.Text = CWData.DISP_NORMAL;
                    lblAllmighty.Text = CWData.DISP_ALLMIGHTY;
                    lblBrave.Text = CWData.DISP_BRAVE;
                    lblDaring.Text = CWData.DISP_DARING;
                    lblResourceful.Text = CWData.DISP_RESOURCEFUL;
                    lblTactician.Text = CWData.DISP_TACTIC;
                }
                else
                {
                    // 身体特性＋精神特性
                    lblNormal.Visible = false;
                    lblNormal1.Visible = false;
                    lblNormal2.Visible = false;
                    lblBrave.Visible = false;
                    lblBrave1.Visible = false;
                    lblBrave2.Visible = false;
                    lblResourceful.Visible = false;
                    lblResourceful1.Visible = false;
                    lblAllmighty.Visible = false;
                    lblAllmighty1.Visible = false;
                    lblAllmighty2.Visible = false;
                    lblDaring.Visible = false;
                    lblDaring1.Visible = false;
                    lblDaring2.Visible = false;
                    lblTactician.Visible = false;
                    lblTactician1.Visible = false;

                    lblChar0.Visible = true;
                    lblChar1.Visible = true;
                    lblChar2.Visible = true;
                    lblChar3.Visible = true;

                    picChar0.Image = HandCard.IconGreen_Bmp[0];
                    picChar1.Image = HandCard.IconGreen_Bmp[1];
                    picChar2.Image = HandCard.IconGreen_Bmp[2];
                    picChar3.Image = HandCard.IconGreen_Bmp[3];

                    picChar0.Visible = true;
                    picChar1.Visible = true;
                    picChar2.Visible = true;
                    picChar3.Visible = true;


                    // 初期設定（グリッド）
                    dgvCharacter.RowHeadersVisible = false;
                    dgvCharacter.ColumnHeadersVisible = true;

                    DataTable dtChara = new DataTable();
                    DataColumn dataCol;

                    string[] colHeaderNames
                    = 
                    {
                        "    ",
                        "好戦",
                        "平和",
                        "社交",
                        "内向",
                        "勇猛",
                        "臆病",
                        "慎重",
                        "大胆",
                        "狡猾",
                        "正直"
                    };

                    dataCol = new DataColumn();
                    dataCol.ColumnName = colHeaderNames[0];

                    dataCol.DataType = typeof(string);
                    dtChara.Columns.Add(dataCol);

                    for (int i = 1; i < colHeaderNames.Length; i++)
                    {
                        dataCol = new DataColumn();
                        dataCol.ColumnName = colHeaderNames[i];
                        dataCol.DataType = typeof(int);
                        dtChara.Columns.Add(dataCol);
                    }

                    DataRow dr;



                    dr = dtChara.NewRow();

                    // 器用度

                    dr[0] = "器用";

                    dr[1] = makeChara.Dex + makeChara.Aggressive;
                    dr[2] = makeChara.Dex - makeChara.Aggressive;

                    dr[3] = makeChara.Dex + makeChara.Cheerful;
                    dr[4] = makeChara.Dex - makeChara.Cheerful;

                    dr[5] = makeChara.Dex + makeChara.Brave;
                    dr[6] = makeChara.Dex - makeChara.Brave;

                    dr[7] = makeChara.Dex + makeChara.Cautious;
                    dr[8] = makeChara.Dex - makeChara.Cautious;

                    dr[9] = makeChara.Dex + makeChara.Trickish;
                    dr[10] = makeChara.Dex - makeChara.Trickish;

                    dtChara.Rows.Add(dr);


                    //敏捷性
                    dr = dtChara.NewRow();

                    dr[0] = "敏捷";

                    dr[1] = makeChara.Agl + makeChara.Aggressive;
                    dr[2] = makeChara.Agl - makeChara.Aggressive;

                    dr[3] = makeChara.Agl + makeChara.Cheerful;
                    dr[4] = makeChara.Agl - makeChara.Cheerful;

                    dr[5] = makeChara.Agl + makeChara.Brave;
                    dr[6] = makeChara.Agl - makeChara.Brave;

                    dr[7] = makeChara.Agl + makeChara.Cautious;
                    dr[8] = makeChara.Agl - makeChara.Cautious;

                    dr[9] = makeChara.Agl + makeChara.Trickish;
                    dr[10] = makeChara.Agl - makeChara.Trickish;

                    dtChara.Rows.Add(dr);

                    //知力
                    dr = dtChara.NewRow();

                    dr[0] = "知力";

                    dr[1] = makeChara.Int + makeChara.Aggressive;
                    dr[2] = makeChara.Int - makeChara.Aggressive;

                    dr[3] = makeChara.Int + makeChara.Cheerful;
                    dr[4] = makeChara.Int - makeChara.Cheerful;

                    dr[5] = makeChara.Int + makeChara.Brave;
                    dr[6] = makeChara.Int - makeChara.Brave;

                    dr[7] = makeChara.Int + makeChara.Cautious;
                    dr[8] = makeChara.Int - makeChara.Cautious;

                    dr[9] = makeChara.Int + makeChara.Trickish;
                    dr[10] = makeChara.Int - makeChara.Trickish;

                    dtChara.Rows.Add(dr);


                    //筋力
                    dr = dtChara.NewRow();

                    dr[0] = "筋力";

                    dr[1] = makeChara.Str + makeChara.Aggressive;
                    dr[2] = makeChara.Str - makeChara.Aggressive;

                    dr[3] = makeChara.Str + makeChara.Cheerful;
                    dr[4] = makeChara.Str - makeChara.Cheerful;

                    dr[5] = makeChara.Str + makeChara.Brave;
                    dr[6] = makeChara.Str - makeChara.Brave;

                    dr[7] = makeChara.Str + makeChara.Cautious;
                    dr[8] = makeChara.Str - makeChara.Cautious;

                    dr[9] = makeChara.Str + makeChara.Trickish;
                    dr[10] = makeChara.Str - makeChara.Trickish;

                    dtChara.Rows.Add(dr);

                    //生命力
                    dr = dtChara.NewRow();

                    dr[0] = "生命";

                    dr[1] = makeChara.Vit + makeChara.Aggressive;
                    dr[2] = makeChara.Vit - makeChara.Aggressive;

                    dr[3] = makeChara.Vit + makeChara.Cheerful;
                    dr[4] = makeChara.Vit - makeChara.Cheerful;

                    dr[5] = makeChara.Vit + makeChara.Brave;
                    dr[6] = makeChara.Vit - makeChara.Brave;

                    dr[7] = makeChara.Vit + makeChara.Cautious;
                    dr[8] = makeChara.Vit - makeChara.Cautious;

                    dr[9] = makeChara.Vit + makeChara.Trickish;
                    dr[10] = makeChara.Vit - makeChara.Trickish;

                    dtChara.Rows.Add(dr);


                    //精神力
                    dr = dtChara.NewRow();

                    dr[0] = "精神";

                    dr[1] = makeChara.Min + makeChara.Aggressive;
                    dr[2] = makeChara.Min - makeChara.Aggressive;

                    dr[3] = makeChara.Min + makeChara.Cheerful;
                    dr[4] = makeChara.Min - makeChara.Cheerful;

                    dr[5] = makeChara.Min + makeChara.Brave;
                    dr[6] = makeChara.Min - makeChara.Brave;

                    dr[7] = makeChara.Min + makeChara.Cautious;
                    dr[8] = makeChara.Min - makeChara.Cautious;

                    dr[9] = makeChara.Min + makeChara.Trickish;
                    dr[10] = makeChara.Min - makeChara.Trickish;

                    dtChara.Rows.Add(dr);

                    dgvCharacter.DataSource = dtChara;

                    // バインド後のグリッド調整

                    for (int i = 0; i < colHeaderNames.Length; i++)
                    {
                        dgvCharacter.Columns[i].Width = 35;
                        dgvCharacter.Columns[i].ReadOnly = true;
                    }


                    dgvCharacter.Visible = true;
                }
            }
            else
            {
                // ８行まで効果を表示可
                // キャラクタの手持ちで丸秘チェックが掛かっている場合
                
                lblAllmighty.Visible = false;
                lblAllmighty1.Visible = false;
                lblAllmighty2.Visible = false;
                lblDaring.Visible = false;
                lblDaring1.Visible = false;
                lblDaring2.Visible = false;
                lblTactician.Visible = false;
                lblTactician1.Visible = false;

                Label[] labels = 
                {
                    this.lblNormal,
                    this.lblNormal1,
                    this.lblNormal2,
                    this.lblBrave,
                    this.lblBrave1,
                    this.lblBrave2,
                    this.lblResourceful,
                    this.lblResourceful1
                };

                int locX = 21;
                int locY = 21;
                foreach (Label label in labels)
                {
                    label.Text = string.Empty;
                    label.Location = new Point(locX, locY);
                    locY += 19;
                }



                //適性
                int apt = Util3.GetCharacterPower(chara,
                                                  data.BodyFacter,
                                                  data.MindFacter,
                                                  0);
                int blessApt = Util3.GetCharacterPower(chara,
                                                  data.BodyFacter,
                                                  data.MindFacter,
                                                  5);

                lblChar0.Text = "通常時(" + apt + ")";

                lblChar2.Text = "祝福時(" + blessApt + ")";
                
                lblChar0.Visible = true;
                lblChar2.Visible = true;

                picChar0.Image = 
                    HandCard.IconGreen_Bmp[GameParam.GetCardFacterColor(chara,
                                                  data.BodyFacter,
                                                  data.MindFacter,
                                                  0)];
                picChar2.Image = 
                    HandCard.IconGreen_Bmp[GameParam.GetCardFacterColor(chara,
                                                  data.BodyFacter,
                                                  data.MindFacter,
                                                  5)];

                picChar0.Visible = true;
                picChar2.Visible = true;


                //総合適性値
                int grandApt = (apt + 1) / 2 + (int)chara.Level;
                if (grandApt < 1) grandApt = 1;
                int blessGrandApt = (blessApt + 1) / 2 + (int)chara.Level;
                if(blessGrandApt < 1) blessGrandApt = 1;

                //効果レベル
                int effectLevel = 0;
                int blessEffectLevel = 0;
                //D10の係数
                int dice10 = 0;
                int blessDice10 = 0;
                //Dnのnの値
                int drnd2 = 0;
                int blessDrnd2 = 0;
                //計算式
                string function = string.Empty;

                string expression = string.Empty;

                bool isWeakPoint = false;

                int index = 0;
                foreach (EffectData ed in data.Effects)
                {
                    effectLevel = 0;
                    blessEffectLevel = 0;
                    dice10 = 0;
                    blessDice10 = 0;
                    drnd2 = 0;
                    blessDrnd2 = 0;

                    function = string.Empty;
                    expression = string.Empty;

                    EffectData.値の種類 kind = ed.ValueKind;
                    switch (kind)
                    {
                        case EffectData.値の種類.レベル比:
                            effectLevel = (grandApt * (int)ed.Value + 1) / 2;
                            blessEffectLevel = (blessGrandApt * (int)ed.Value + 1) / 2;
                            break;
                        case EffectData.値の種類.直接:
                            effectLevel = (int)ed.Value;
                            blessEffectLevel = (int)ed.Value;
                            break;
                    }

                    dice10 = effectLevel / 5;
                    blessDice10 = blessEffectLevel / 5;

                    drnd2 = (effectLevel % 5) * 2;
                    blessDrnd2 = (blessEffectLevel % 5) * 2;

                    if (kind == EffectData.値の種類.最大値処理)
                    {
                        function = "最大値処理";
                    } 
                    else if (dice10 == 0)
                    {
                        if (drnd2 == 0)
                        {
                            // なにもしないときは使わないはず
                            function = string.Empty;
                        }
                        else
                        {
                            function = "D" + drnd2 + " (平均："
                                + ((drnd2 + 1.0) / 2.0) + ")";
                        }
                    }
                    else
                    {
                        if (drnd2 == 0)
                        {
                            function = dice10 + "D10 (平均：" + (dice10 * 5.5) + ")";
                        }
                        else
                        {
                            function = dice10 + "D10+D" + drnd2 + " (平均：" 
                                + (dice10 * 5.5 + (drnd2 + 1.0) / 2.0) + ")";
                        }
                    }

                    if (kind != EffectData.値の種類.最大値処理 &&
                        data.WidID == WidIDtype.スキル)
                    {
                        function += " 祝福時：";
                        if (blessDice10 == 0)
                        {
                            if (blessDrnd2 == 0)
                            {
                                // なにもしないときは使わないはず
                                function += string.Empty;
                            }
                            else
                            {
                                function += "D" + blessDrnd2 + " (平均："
                                    + ((blessDrnd2 + 1.0) / 2.0) + ")";
                            }
                        }
                        else
                        {
                            if (blessDrnd2 == 0)
                            {
                                function += blessDice10 + "D10 (平均：" + (blessDice10 * 5.5) + ")";
                            }
                            else
                            {
                                function += blessDice10 + "D10+D" + blessDrnd2 + " (平均："
                                    + (blessDice10 * 5.5 + (blessDrnd2 + 1.0) / 2.0) + ")";
                            }
                        }
                    }

                    switch (ed.EffectTab)
                    {
                        case EffectData.効果タブ.生命力:
                            //生命力
                            expression += " 生命ー" +
                            ((EffectData.生命力)ed.EffectNumberInTab).ToString()
                            + " "
                            + ed.Attribute.ToString()
                            + ":"
                            + function;

                            if (ed.Attribute == EffectData.属性.炎 ||
                               ed.Attribute == EffectData.属性.冷気)
                            {
                                isWeakPoint = true;
                            }

                            break;
                        case EffectData.効果タブ.肉体:
                            //肉体
                            expression += " 肉体ー" +
                            ((EffectData.肉体)ed.EffectNumberInTab).ToString()
                            + " "
                            + ed.Attribute.ToString()
                            + ":"
                            + function;

                            if (ed.EffectNumberInTab % 2 == 0 &&
                                (ed.Attribute == EffectData.属性.炎 ||
                               ed.Attribute == EffectData.属性.冷気))
                            {
                                // 麻痺・中毒で炎か冷気
                                isWeakPoint = true;
                            }

                            break;
                        case EffectData.効果タブ.技能:
                            //技能
                            expression += " 技能ー" +
                            ((EffectData.技能)ed.EffectNumberInTab).ToString();
                            break;
                        case EffectData.効果タブ.精神:
                            expression += " 精神ー" +
                            ((EffectData.精神)ed.EffectNumberInTab).ToString();
                            ////+" "
                            ////+ ed.Attribute.ToString()

                            if (EffectData.精神.正常状態 !=
                                (EffectData.精神)ed.EffectNumberInTab)
                            {
                                expression += ":" + ed.Round + "R";
                            }
                            break;
                        case EffectData.効果タブ.魔法:
                            expression += " 魔法ー" +
                            ((EffectData.魔法)ed.EffectNumberInTab).ToString();
                            ////+" "
                            ////+ ed.Attribute.ToString()

                            if (ed.EffectNumberInTab % 2 == 0)
                            {
                                expression += ":" + ed.Round + "R";
                            }
                            break;
                        case EffectData.効果タブ.能力:
                            expression += " 能力ー" +
                            ((EffectData.能力)ed.EffectNumberInTab).ToString();
                            ////+" "
                            ////+ ed.Attribute.ToString()
                            expression += ":"
                                + ed.MagicValue + " "
                                + ed.Round + "R";
                            break;
                        case EffectData.効果タブ.消滅:
                            //消滅
                            expression += " 消滅ー" +
                            ((EffectData.消滅)ed.EffectNumberInTab).ToString();
                            break;
                        case EffectData.効果タブ.カード:
                            //カード
                            expression += " カードー" +
                            ((EffectData.カード)ed.EffectNumberInTab).ToString();
                            break;
                        case EffectData.効果タブ.召喚:
                            //召喚
                            expression += " 召喚ー" +
                            ((EffectData.召喚)ed.EffectNumberInTab).ToString();
                            expression += " " + ed.Beast.CardName;
                            break;
                    }

                    labels[index++].Text = expression;

                    if (isWeakPoint)
                    {
                        labels[labels.Length - 1].Text
                        = "対象の弱点が炎や冷気の場合、その属性の攻撃力は2D10(平均11)増加。";
                    }

                    if (index == labels.Length - 1) return;
                }
            }
        }




        /// <summary>
        /// フォーム表示時
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ExpressionDlg_Shown(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// 閉じるボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEnd_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// フォームが閉じられる時のイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ExpressionDlg_FormClosing(object sender, FormClosingEventArgs e)
        {

        }

        #endregion


    }
}