using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using CWIDatas;
using CWI.Card;
using CWI.Button;
using System.Text.RegularExpressions;

namespace CWI.Dialog
{
    public enum CharacterDataType
    {
        Expression,
        Coupon,
        Edit,
        Skill,
        Item,
        Beast
    }

    public partial class PcDetailDlg : CWI.Dialog.SelectableForm
    {
        //\ׂvf
        private List<CharacterData> datas;
        private CharacterData data;
        private string oldCardName = string.Empty;
        private string oldButton = string.Empty;
        private CharacterDataType pushedButton = CharacterDataType.Expression;
        private Brush SolidWhite = new SolidBrush(Color.White);

        private PartyMaker _pm = null;
        private InnData inn = null;

        List<Label> list = new List<Label>();
        int listIndex = 0;
        CharacterData cd = null;
        List<HandCard> hands = new List<HandCard>();

        // ݑI𒆂̃CfbNX
        public int SelectedIndex
        {
            get
            {
                return this.index;
            }
        }

        public PcDetailDlg(PartyMaker pm, CharacterData data)
        {
            InitializeComponent();

            _pm = pm;
            MouseWheel += new MouseEventHandler(Pnl_MouseWheel);

            //{^ݒ
            BtnCancel.Text = "";
            tablist.Add(BtnCancel);
            SetUpPosition();//ʒu킹

            count = 1;
            index = 0;
            datas = new List<CharacterData>();
            datas.Add(data);

            SetUpData();
        }

        public PcDetailDlg(PartyMaker pm, InnData inn, List<CharacterData> datas, int index)
        {
            InitializeComponent();

            _pm = pm;
            MouseWheel += new MouseEventHandler(Pnl_MouseWheel);

            //{^ݒ
            BtnCancel.Text = "";
            tablist.Add(BtnCancel);
            SetUpPosition();//ʒu킹

            this.datas = datas;
            this.count = datas.Count;
            this.index = index;

            SetUpData();

            this.inn = inn;
        }

        protected override void SetUpPosition()
        {
            base.SetUpPosition();

            this.Height += this.PushPanel.Height + 1;

            this.LblTitle.Top = this.ViewPanel.Top + 99;
            this.LblTitle.Left = this.ViewPanel.Left + 1;
            this.LblTitle.Width = this.ViewPanel.Width - 2;

            this.DetailSize.Top = this.ViewPanel.Top + 120;
            this.DetailSize.Left = this.ViewPanel.Left + 1;
            this.DetailSize.Width = this.ViewPanel.Width - 2;
            this.DetailSize.Height = this.ViewPanel.Height - 121;

            this.ViewPanel.Height = 98;

            this.DetailPanel.Top = 0;
            this.DetailPanel.Left = 0;
            this.DetailPanel.Width = this.DetailSize.Width;

            this.PushPanel.Top = this.SystemPanel.Top;
            this.PushPanel.Width = this.SystemPanel.Width;
            this.PushPanel.Visible = true;
            this.SystemPanel.Top += this.PushPanel.Height + 1;

            this.Invalidate();

        }

        protected override void SetUpData()
        {
            base.SetUpData();
        }

        protected override void doPrevPage()
        {
            if (count == 0)
                return;
            if (index == 0)
                index = count - 1;
            else
                index--;


            selectButtonClick();
        }
        protected override void doNextPage()
        {
            if (count == 0)
                return;
            index++;
            if (index == count)
                index = 0;


            selectButtonClick();
        }
        protected override void doFirstPage()
        {

            if (count <= 1)
                return;
            if (index == 0)
                index = count - 1;
            else
                index = 0;


            selectButtonClick();
        }
        protected override void doLastPage()
        {

            if (count <= 1)
                return;
            if (index == count - 1)
                index = 0;
            else
                index = count - 1;

            selectButtonClick();
            
        }

        private void selectButtonClick()
        {
            switch (pushedButton)
            {
                case CharacterDataType.Expression:
                    radioButton1.PerformClick();
                    break;
                case CharacterDataType.Coupon:
                    radioButton2.PerformClick();
                    break;
                case CharacterDataType.Edit:
                    radioButton3.PerformClick();
                    break;
                case CharacterDataType.Skill:
                    radioButton4.PerformClick();
                    break;
                case CharacterDataType.Item:
                    radioButton5.PerformClick();
                    break;
                case CharacterDataType.Beast:
                    radioButton6.PerformClick();
                    break;
            }
        }

        protected override void ShowPage()
        {
            ViewBitmap = new Bitmap(ViewPanel.Width, ViewPanel.Height);
            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {
                data = datas[index];

                string sex = "";// 
                string age = "";// 
                string ep = "0";// EP 
                //string type = "";//f^

                List<CouponData> dispCoupons = new List<CouponData>();
                foreach (CouponData coup in data.Coupons)
                {//N[|JԂ
                    string s = coup.Name;
                    if (!Regex.IsMatch(s, "(Q|)"))
                    {//sɁ@Q܂܂ĂȂ
                        dispCoupons.Add(coup);
                    }
                    else
                    {//Qf
                        //܂܂ł
                        if (s.Equals(CWData.STR_MALE)) { sex = ""; }
                        if (s.Equals(CWData.STR_FEMALE)) { sex = ""; }
                        if (s.Equals(CWData.STR_CHILD)) { age = "q"; }
                        if (s.Equals(CWData.STR_YOUNG)) { age = ""; }
                        if (s.Equals(CWData.STR_ADULT)) { age = "l"; }
                        if (s.Equals(CWData.STR_OLD)) { age = "Vl"; }
                        if (s.Equals(CWData.STR_EP)) { ep = coup.Point.ToString(); }

                        // Ȃ̂ŃRgAEg
                        ////if (_pm.paramOption == true)
                        ////{
                        ////    dispCoupons.Add(coup);
                        ////}
                    }
                }
                dispCoupons.Reverse();

                // LN^摜
                if (data.Image.empty == false)
                {
                    if (_pm.paramOption == false)
                    {
                        // OGŏ̎qoꍇ
                        g.DrawImage(data.Image.bitmap,
                            // ViewPanel̕\ʒu
                            new Rectangle(ViewPanel.ClientSize.Width / 2 - CWData.Bitmap_Width / 2, 4,
                                CWData.Bitmap_Width, CWData.Bitmap_Height),
                            new Rectangle(0, 0,
                                CWData.Bitmap_Width, CWData.Bitmap_Height),
                            GraphicsUnit.Pixel);
                    }
                    else
                    {

                        ////// OGőFLoꍇ
                        ////g.DrawImage(data.Image.bitmap,
                        ////    // ViewPanel̕\ʒu
                        ////    new Rectangle(ViewPanel.ClientSize.Width / 2 - CWData.Bitmap_Width / 2, 4,
                        ////        CWData.Bitmap_Width, CWData.Bitmap_Height),
                        ////    new Rectangle(data.Image.bitmap.Width / 2 - CWData.Bitmap_Width / 2,
                        ////        data.Image.bitmap.Height / 2 - CWData.Bitmap_Height / 2,
                        ////        CWData.Bitmap_Width, CWData.Bitmap_Height),
                        ////    GraphicsUnit.Pixel);

                        // OGŏ̎qijoꍇ
                        g.DrawImage(data.Image.bitmap,
                            // ViewPanel̕\ʒu
                            new Rectangle(ViewPanel.ClientSize.Width / 2 - CWData.Bitmap_Width / 2, 4,
                                CWData.Bitmap_Width, CWData.Bitmap_Height),
                            new Rectangle(data.Image.bitmap.Width / 2 - CWData.Bitmap_Width / 2,
                                data.Image.bitmap.Height - CWData.Bitmap_Height,
                                CWData.Bitmap_Width, CWData.Bitmap_Height),
                            GraphicsUnit.Pixel);
                    }
                }

                // DetailPanel obNOEhC[W
                Image logo = Image.FromFile(FilePath.GetLogoFile());

                Bitmap bit = logo as Bitmap;
                bit.MakeTransparent(bit.GetPixel(0, 0));
                this.DetailPanel.BackgroundImage = logo;
                this.DetailPanel.Controls.Clear();

                Bitmap bit2 = CWIEngine.Properties.Resources.Bitmap_198;
                bit2.MakeTransparent(bit2.GetPixel(0, 0));
                this.ViewPanel.BackgroundImage = new Bitmap(this.ViewPanel.Width,this.ViewPanel.Height);
                Graphics gv = Graphics.FromImage(this.ViewPanel.BackgroundImage);
                gv.DrawImage(bit2, 30, 20);

                using (Font smallFont = new Font("lr ", 9, FontStyle.Bold))
                {
                    Rectangle rect = new Rectangle();

                    StringFormat format = new StringFormat();

                    //////
                    ////format.Alignment = StringAlignment.Center;

                    //x
                    uint maxLv = Util1.GetMaxLevel(data);
                    if (data.Level == maxLv)
                    {
                        g.DrawString("LevelF" + data.Level, smallFont, SolidBlack, 4, 4);
                    }
                    else
                    {
                        g.DrawString("LevelF" + data.Level + "/" + maxLv, smallFont, SolidBlack, 4, 4);
                    }

                    //EP
                    g.DrawString("EPF" + ep, smallFont, SolidBlack, 4, 85);

                    //O
                    format.Alignment = StringAlignment.Far;
                    rect.X = ViewPanel.ClientSize.Width - 100;
                    rect.Y = 4;
                    rect.Width = 96;
                    rect.Height = 15;
                    g.DrawString(data.CardName, smallFont, SolidBlack, rect, format);

                    //Age,Sex
                    rect.Y = 85;
                    g.DrawString(age + " " + sex, smallFont, SolidBlack, rect, format);

                    int height = 0;

                    // ݕ\̃LN^
                    oldCardName = data.CardName;

                    DetailPanel.Controls.Clear();
                    DetailPanel.AutoScrollPosition = new Point(0, 0);
                    
                    list = new List<Label>();
                    
                    listIndex = 0;

                    switch (pushedButton)
                    {
                        case CharacterDataType.Expression:
                            this.LblTitle.Text = "";

                            // ݕ\̃WI{^
                            oldButton = "radioButton1";

                            //
                            height = 4;
                            foreach (string expressLine
                                in data.Expression.Replace("\r\n", "\n").Split('\n'))
                            {
                                Label label = new Label();
                                label.Left = 12;
                                label.Top = height;
                                label.TextAlign = ContentAlignment.MiddleLeft;
                                label.BackColor = Color.Transparent;
                                label.ForeColor = Color.White;
                                label.AutoSize = true;
                                label.Font = new Font("lr ", 9, FontStyle.Bold);

                                if (expressLine.Trim(' ', '@', '\t') == "TEXT")
                                {
                                    label.Text = string.Empty;
                                }
                                else
                                {
                                    label.Text = expressLine;
                                }

                                height += 15;
                                list.Add(label);
                            }

                            DetailPanel.Controls.AddRange(list.ToArray());

                            break;

                        case CharacterDataType.Coupon:
                            this.LblTitle.Text = "o";

                            // ݕ\̃WI{^
                            oldButton = "radioButton2";

                            // o
                            height = 10;
                            List<PictureBox> lstPic = new List<PictureBox>();
                            foreach (CouponData coup in dispCoupons)
                            {

                                Bitmap lank;
                                if(coup.Point >= 2)
                                   lank = CWIEngine.Properties.Resources.Bitmap_147;
                                else if (coup.Point == 1)
                                {
                                    lank = CWIEngine.Properties.Resources.Bitmap_146;
                                }
                                else if (coup.Point == 0)
                                {
                                    lank = CWIEngine.Properties.Resources.Bitmap_141;
                                }
                                else
                                {
                                    lank = CWIEngine.Properties.Resources.Bitmap_140;
                                }
                                lank.MakeTransparent(lank.GetPixel(0, 0));
                                PictureBox pic = new PictureBox();
                                pic.Image = lank;
                                pic.Top = height;
                                pic.Left = 5;
                                pic.Size = new Size(15, 15);
                                lstPic.Add(pic);

                                Label label = new Label();
                                label.Left = 25; //12;
                                label.Top = height;
                                label.TextAlign = ContentAlignment.MiddleLeft;
                                label.BackColor = Color.Transparent;
                                label.ForeColor = Color.White;
                                label.AutoSize = true;
                                label.Font = new Font("lr ", 9, FontStyle.Bold);

                                label.Text = //coup.Point.ToString().PadLeft(3,' ') + " : " +
                                             coup.Name;

                                height += 15;
                                list.Add(label);
                            }

                            DetailPanel.Controls.AddRange(lstPic.ToArray());
                            DetailPanel.Controls.AddRange(list.ToArray());

                            break;
                        case CharacterDataType.Edit:
                            this.LblTitle.Text = "ҏW";
                            // ݕ\̃WI{^
                            oldButton = "radioButton3";


                            break;
                        case CharacterDataType.Skill:
                            this.LblTitle.Text = "Z\J[h";
                            // ݕ\̃WI{^
                            oldButton = "radioButton4";

                            // Z\J[h
                            height = 10;
                            foreach (WidCard skillCard in data.Skills)
                            {
                                Label label = new Label();
                                label.Left = 35;
                                label.Top = height;
                                label.TextAlign = ContentAlignment.MiddleLeft;
                                label.BackColor = Color.Transparent;
                                label.ForeColor = Color.White;
                                label.AutoSize = true;
                                label.Font = new Font("lr ", 9, FontStyle.Bold);

                                label.Text = skillCard.CardName;

                                label.Enabled = true;
                                label.MouseEnter += new EventHandler(label_MouseEnter);
                                label.MouseLeave += new EventHandler(label_MouseLeave);
                                label.MouseDown += new MouseEventHandler(label_MouseDown);

                                list.Add(label);
                                height += 15;
                            }

                            DetailPanel.Controls.AddRange(list.ToArray());

                            break;
                        case CharacterDataType.Item:
                            this.LblTitle.Text = "ACeJ[h";
                            // ݕ\̃WI{^
                            oldButton = "radioButton5";

                            // ACeJ[h
                            height = 10;
                            foreach (WidCard itemCard in data.Items)
                            {
                                Label label = new Label();
                                label.Left = 35;
                                label.Top = height;
                                label.TextAlign = ContentAlignment.MiddleLeft;
                                label.BackColor = Color.Transparent;
                                label.ForeColor = Color.White;
                                label.AutoSize = true;
                                label.Font = new Font("lr ", 9, FontStyle.Bold);

                                label.Text = itemCard.CardName;

                                label.Enabled = true;
                                label.MouseEnter += new EventHandler(label_MouseEnter);
                                label.MouseLeave += new EventHandler(label_MouseLeave);
                                label.MouseDown += new MouseEventHandler(label_MouseDown);

                                list.Add(label);
                                height += 15;
                            }

                            DetailPanel.Controls.AddRange(list.ToArray());

                            break;
                        case CharacterDataType.Beast:
                            this.LblTitle.Text = "bJ[h";
                            // ݕ\̃WI{^
                            oldButton = "radioButton6";

                            // bJ[h
                            height = 10;
                            foreach (WidCard beastCard in data.Beasts)
                            {
                                Label label = new Label();
                                label.Left = 35;
                                label.Top = height;
                                label.TextAlign = ContentAlignment.MiddleLeft;
                                label.BackColor = Color.Transparent;
                                label.ForeColor = Color.White;
                                label.AutoSize = true;
                                label.Font = new Font("lr ", 9, FontStyle.Bold);

                                label.Text = beastCard.CardName;

                                label.Enabled = true;
                                label.MouseEnter += new EventHandler(label_MouseEnter);
                                label.MouseLeave += new EventHandler(label_MouseLeave);
                                label.MouseDown += new MouseEventHandler(label_MouseDown);

                                list.Add(label);
                                height += 15;
                            }

                            DetailPanel.Controls.AddRange(list.ToArray());

                            break;

                    }
                }
            }

            ViewPanel.Invalidate();
            DetailPanel.Invalidate();
        }

        void label_MouseDown(object sender, MouseEventArgs e)
        {
            cd = datas[index];
            hands = new List<HandCard>();
            if (GetHandsCards(cd, hands) == false || hands.Count == 0) return;

            using (CardInfoDialog cid
                = new CardInfoDialog(_pm.paramOption,
                                     cd,
                                     hands,
                                     listIndex))
            {
                cid.ShowDialog();
            }
        }

        void label_MouseLeave(object sender, EventArgs e)
        {
            list[listIndex].ForeColor = Color.White;
            listIndex = 0;
        }

        void label_MouseEnter(object sender, EventArgs e)
        {
            // Ώ
            Point pt = DetailPanel.PointToClient(Cursor.Position);
            int indexOfY = (-DetailPanel.AutoScrollPosition.Y + pt.Y - 10) / 15;

            if (indexOfY >= 0 && indexOfY < list.Count)
            {
                // ͈͓
                this.listIndex = indexOfY;
                list[listIndex].ForeColor = Color.Red;

            }
        }

        private void PcDetailDlg_Shown(object sender, EventArgs e)
        {

        }

        private void radioButton_Click(object sender, EventArgs e)
        {
            RadioButton rad = sender as RadioButton;
            if (rad != null)
            {
                if (rad.Checked)
                {
                    if (oldButton == rad.Name && oldCardName == datas[index].CardName)
                    {
                        return;
                    }

                    MultiMedia.SoundWavFile(FilePath.GetWavePage());
                    switch (rad.Name)
                    {
                        case "radioButton1":
                            pushedButton = CharacterDataType.Expression;
                            break;
                        case "radioButton2":
                            pushedButton = CharacterDataType.Coupon;
                            break;
                        case "radioButton3":
                            pushedButton = CharacterDataType.Edit;
                            break;
                        case "radioButton4":
                            pushedButton = CharacterDataType.Skill;
                            break;
                        case "radioButton5":
                            pushedButton = CharacterDataType.Item;
                            break;
                        case "radioButton6":
                            pushedButton = CharacterDataType.Beast;
                            break;
                    }

                    ShowPage();
                }
            }
        }

        private void DetailPanel_Click(object sender, EventArgs e)
        {
            cd = datas[index];
            hands = new List<HandCard>();

            if (GetHandsCards(cd, hands) == false || hands.Count == 0) return;

            using (CardInfoDialog cid
                = new CardInfoDialog(_pm.paramOption,
                                     cd,
                                     hands,
                                     0))
            {
                cid.ShowDialog();
            }
        }

        private bool GetHandsCards(CharacterData cd, List<HandCard> hands)
        {
            switch (pushedButton)
            {
                case CharacterDataType.Skill:
                    SkillHandCard shc = null;
                    foreach (WidCard wc in cd.Skills)
                    {
                        shc = new SkillHandCard(wc);

                        shc.UpdateImage(GameParam.GetCardFacterColor(cd,
                            shc.widData.BodyFacter,
                            shc.widData.MindFacter),
                            GameParam.GetSkillRemainColor(shc.widData.SkillRemainUseCount,
                            GameParam.GetMaxSkillUseCount(cd.Level, shc.widData.Level)));

                        hands.Add(shc);
                    }

                    break;
                case CharacterDataType.Item:
                    ItemHandCard ihc = null;
                    foreach (WidCard wc in cd.Items)
                    {
                        ihc = new ItemHandCard(wc);

                        ihc.UpdateImage(GameParam.GetCardFacterColor(cd,
                            ihc.widData.BodyFacter,
                            ihc.widData.MindFacter));

                        hands.Add(ihc);
                    }
                    break;
                case CharacterDataType.Beast:
                    BeastHandCard bhc = null;
                    foreach (WidCard wc in cd.Beasts)
                    {
                        bhc = new BeastHandCard(wc);

                        bhc.UpdateImage(GameParam.GetCardFacterColor(cd,
                            bhc.widData.BodyFacter,
                            bhc.widData.MindFacter));

                        hands.Add(bhc);
                    }
                    break;
                default:
                    return false;
            }
            return true;
        }

        private void PcDetailDlg_KeyDown(object sender, KeyEventArgs e)
        {
            //KeyCode + Modifiers = KeyData
            if ((e.Modifiers & Keys.Control) == Keys.Control)
            {
                if (e.KeyCode == Keys.Left)
                {
                    doPrevPage();
                }
                else if (e.KeyCode == Keys.Right)
                {
                    doNextPage();
                }
            }
        }


        /// <summary>
        /// }EXzC[̈ړʂ擾
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Pnl_MouseWheel(object sender, MouseEventArgs e)
        {
            ScrollPnl(-e.Delta);
        }

        /// <summary>
        /// ړʕXN[(ڍ׃pl)
        /// </summary>
        /// <param name="delta"></param>
        private void ScrollPnl(int delta)
        {
            int nowX = -DetailPanel.AutoScrollPosition.X;
            int nowY = -DetailPanel.AutoScrollPosition.Y;

            nowY += delta;

            if (nowY < 0)
            {
                nowY = 0;
            }

            if (nowY > 10 + 15 * DetailPanel.Controls.Count)
            {
                nowY = 10 + 15 * DetailPanel.Controls.Count;
            }

            DetailPanel.AutoScrollPosition = new Point(nowX, nowY);

        }

    }//class


}//namespace