﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CWI;

namespace CWI.Dialog
{
    public partial class ProgressDlg : Form
    {
        public ProgressDlg()
        {
            InitializeComponent();

            this.BackgroundImage = CWIEngine.Properties.Resources.MessageDlgBackGround;
            this.ShowInTaskbar = false;
        }

        private Form _owner;
        public ProgressDlg(Form owner)
        {
            InitializeComponent();

            _owner = owner;
            this.StartPosition = FormStartPosition.Manual;
            this.Left =
            _owner.Left + (_owner.Width - this.Width) / 2;
            this.Top =
                _owner.Top + (_owner.Height - this.Height) / 2;

            this.BackgroundImage = CWIEngine.Properties.Resources.MessageDlgBackGround;
            this.ShowInTaskbar = false;
        }

        private void ProgressDlg_Load(object sender, EventArgs e)
        {
            _loadOn = true;
        }

        #region プロパティ

        private bool _loadOn = false;
        public bool LoadOn
        {
            get
            {
                return _loadOn;
            }
        }


        private int _value = 0;
        public int Value
        {
            get
            {
                return _value;
            }

            set
            {
                _value = value;
                this.Invoke(new MethodInvoker(SetProgressValue));
            
            }
        }


        private int _maximum = 0;
        public int Maximum
        {
            set
            {
                _maximum = value;
                this.Invoke(new MethodInvoker(SetProgressMaximun));
            }
        }

        private int _minimum = 0;
        public int Minimum
        {
            set
            {
                _minimum = value;
                this.Invoke(new MethodInvoker(SetProgressMinimum));

            }
        }

        private string _title = string.Empty;
        public string Title
        {
            set
            {
                _title = value;
                this.Invoke(new MethodInvoker(SetTitle));
            }
        }

        private string _message = string.Empty;
        public string Message
        {
            set
            {
                _message = value;
                this.Invoke(new MethodInvoker(SetMessage));
            }

        }

        public void CloseDialog()
        {
            this.Invoke(new MethodInvoker(Close));
        }

        private void SetProgressValue()
        {
            this.progressBar1.Value = _value;
            this.Activate();
        }

        private void SetMessage()
        {
            this.label1.Text = _message;
            this.Activate();
        }

        private void SetTitle()
        {
            this.Text = _title;
            this.Activate();
        }

        private void SetProgressMaximun()
        {
            this.progressBar1.Maximum = _maximum;
            this.Activate();
        }

        private void SetProgressMinimum()
        {
            this.progressBar1.Minimum = _minimum;
            this.Activate();
        }

        #endregion


    }
}
