/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.Drawing;
using System.Windows.Forms;
using CWI.Button;
using CWI;

namespace CWI.Dialog
{
    /// <summary>
    /// Description of SelectableForm.
    /// </summary>
    public partial class SelectableForm
    {
        protected static Brush SolidBlack = new SolidBrush(Color.Black);
        protected static Brush SolidBlue = new SolidBrush(Color.Blue);

        public SelectableForm()
        {
            InitializeComponent();
            ((PanelButtonRepeat)BtnFirst).SetUp(BtnFirst_Execute, BtnFirst_Draw, this.btnTimer);
            ((PanelButtonRepeat)BtnLast).SetUp(BtnLast_Execute, BtnLast_Draw, this.btnTimer);
            ((PanelButtonRepeat)BtnPrev).SetUp(BtnPrev_Execute, BtnPrev_Draw, this.btnTimer);
            ((PanelButtonRepeat)BtnNext).SetUp(BtnNext_Execute, BtnNext_Draw, this.btnTimer);
            tablist = new TabList();

            MouseWheel += new MouseEventHandler(SelectableForm_MouseWheel);
        }

        /// <summary>
        /// }EXzC[̈ړʂ擾
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SelectableForm_MouseWheel(object sender, MouseEventArgs e)
        {
            if (e.Delta < -10)
            {
                doNextPage();
            }
            else if (e.Delta > 10)
            {
                doPrevPage();
            }
        }

        /// <summary>
        /// EBhETCYɂ҂ɂȂ悤ɁApl𒲐
        /// </summary>
        protected virtual void SetUpPosition()
        {
            //pl̈ʒu킹
            SystemPanel.Left = 0;
            SystemPanel.Height = 28;
            SystemPanel.Top = this.ClientSize.Height - SystemPanel.Height;
            SystemPanel.Width = this.ClientSize.Width;
            ViewPanel.Width = this.ClientSize.Width;
            ViewPanel.Height = SystemPanel.Top - 1;
            ViewBitmap = new Bitmap(ViewPanel.Width, ViewPanel.Height);
            //{^̈ʒu킹
            int btnWidth = 31;
            BtnFirst.Left = 0;
            BtnFirst.Width = btnWidth;
            BtnPrev.Left = BtnFirst.Width - 1;
            BtnPrev.Width = btnWidth;
            CoverPanel.Left = BtnPrev.Left + BtnPrev.Width - 1;
            BtnLast.Width = btnWidth;
            BtnLast.Left = SystemPanel.Width - BtnLast.Width;
            BtnNext.Width = btnWidth;
            BtnNext.Left = BtnLast.Left - BtnNext.Width + 1;
            CoverPanel.Width = BtnNext.Left - CoverPanel.Left;
            //s{^̈ʒu킹
            if (tablist.Count == 0)
                return;
            int twidth = tablist[0].Width;
            int remain = CoverPanel.Width - twidth * tablist.Count;
            int dr = remain / (tablist.Count + 1);
            int dx = dr + twidth;
            for (int j = 0; j < tablist.Count; j++)
            {
                tablist[j].Left = dr + dx * j;
                tablist[j].Top = 4;
                tablist[j].Height = 21;
                tablist[j].Width = twidth;
            }
        }

        protected int index;
        protected int count;
        protected TabList tablist;

        #region r[}EXɂI
        private byte state;//1ŒA2ōA3ŉE
        private void ViewPanel_MouseMove(object sender, MouseEventArgs e)
        {
            if (count == 0)
                state = 0;
            if (count == 1)
                state = 1;
            else if (e.X < ViewPanel.Width / 4)
                state = 2;
            else if (e.X > ViewPanel.Width * 3 / 4)
                state = 3;
            else
                state = 1;
            switch (state)
            {
                case 0:
                    ViewPanel.Cursor = System.Windows.Forms.Cursors.Default;
                    break;
                case 1:
                    ViewPanel.Cursor = System.Windows.Forms.Cursors.UpArrow;
                    break;
                case 2:
                    ViewPanel.Cursor = System.Windows.Forms.Cursors.PanWest;
                    break;
                case 3:
                    ViewPanel.Cursor = System.Windows.Forms.Cursors.PanEast;
                    break;
            }

        }
        private void ViewPanel_MouseLeave(object sender, EventArgs e)
        {
            state = 0;
        }
        private void ViewPanel_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                switch (state)
                {
                    case 0:
                        return;
                    case 1:
                        doSelectPage();
                        return;
                    case 2:
                        doPrevPage();
                        return;
                    case 3:
                        doNextPage();
                        return;
                }
            }
            if (e.Button == MouseButtons.Right)
                if (state != 0)
                {
                    MultiMedia.SoundClick();
                    doCancel();
                }
        }
        #endregion

        #region ʊG
        protected Bitmap ViewBitmap;
        private void ViewPanel_Paint(object sender, PaintEventArgs e)
        {
            if (ViewBitmap != null)
                e.Graphics.DrawImage(ViewBitmap, ViewPanel.Location);
        }
        #endregion

        #region y[WAyь
        protected virtual void doPrevPage()
        {
            if (count == 0)
                return;
            if (index == 0)
                index = count - 1;
            else
                index--;
            MultiMedia.SoundWavFile(FilePath.GetWavePage());
            ShowPage();
        }
        protected virtual void doNextPage()
        {
            if (count == 0)
                return;
            index++;
            if (index == count)
                index = 0;
            MultiMedia.SoundWavFile(FilePath.GetWavePage());
            ShowPage();
        }

        protected virtual void doPrev10Page()
        {
            if (count == 0)
                return;
            if (index == 0)
                return;
            else
            {
                index -= 10;
                if (index < 0)
                {
                    index = 0;
                }
            }
            MultiMedia.SoundWavFile(FilePath.GetWavePage());
            ShowPage();
        }

        protected virtual void doNext10Page()
        {
            if (count == 0)
                return;
            if (index == count - 1)
                return;
            else
            {
                index += 10;
                if (index >= count)
                {
                    index = count - 1;
                }
            }
            MultiMedia.SoundWavFile(FilePath.GetWavePage());
            ShowPage();
        }

        protected virtual void doFirstPage()
        {
            if (count <= 1)
                return;
            if (index == 0)
                index = count - 1;
            else
                index = 0;
            MultiMedia.SoundWavFile(FilePath.GetWavePage());
            ShowPage();
        }
        protected virtual void doLastPage()
        {
            if (count <= 1)
                return;
            if (index == count - 1)
                index = 0;
            else
                index = count - 1;
            MultiMedia.SoundWavFile(FilePath.GetWavePage());
            ShowPage();
        }
        //qNXŃI[o[Ch
        protected virtual void doSelectPage() { }
        protected virtual void ShowPage() {}
        protected virtual void SetUpData()
        {
            if (count > 1)
            {
                BtnFirst.SetBtnEnable(true);
                BtnPrev.SetBtnEnable(true);
                BtnNext.SetBtnEnable(true);
                BtnLast.SetBtnEnable(true);
            }
            else
            {
                BtnFirst.SetBtnEnable(false);
                BtnPrev.SetBtnEnable(false);
                BtnNext.SetBtnEnable(false);
                BtnLast.SetBtnEnable(false);
            }
        }
        protected virtual void doCancel()
        {
            this.DialogResult = DialogResult.Cancel;
        }
        #endregion

        #region {^Cxg
        private void Select_Click(object sender, EventArgs e)
        {
            doSelectPage();
        }

        private void Cancel_Click(object sender, EventArgs e)
        {
            MultiMedia.SoundClick();
            doCancel();
        }
        #endregion

        private void SelectableForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            ViewPanel.Cursor = System.Windows.Forms.Cursors.Default;
        }

        #region plƑ{^Cxg
        private void VisuPanel_Paint(object sender, PaintEventArgs e)
        {
            Pen pen;
            using (pen = new Pen(Color.White))
            {
                e.Graphics.DrawLine(pen, 0, 0, CoverPanel.Width - 1, 0);
                e.Graphics.DrawLine(pen, 0, 0, 0, CoverPanel.Height - 1);
            }
            using (pen = new Pen(Color.FromArgb(128, 128, 128)))
            {
                e.Graphics.DrawLine(pen, CoverPanel.Width - 1, CoverPanel.Height - 1, CoverPanel.Width - 1, 0);
                e.Graphics.DrawLine(pen, CoverPanel.Width - 1, CoverPanel.Height - 1, 0, CoverPanel.Height - 1);
            }
        }

        //u擪ցv{^
        private void BtnFirst_Execute()
        {
            doFirstPage();
        }
        private void BtnFirst_Draw(Graphics g, bool pushed, bool enabled)
        {
            //Op`QG
            for (int k = 0; k < 2; k++)
            {
                int dx = k * 7 - 4;
                if (!enabled)
                {
                    Pen pen;
                    using (pen = new Pen(Color.White))
                    {
                        g.DrawLine(pen, 13 + dx, 14, 19 + dx, 8);
                        g.DrawLine(pen, 19 + dx, 8, 19 + dx, 20);
                    }
                    using (pen = new Pen(Color.FromArgb(128, 128, 128)))
                    {
                        g.DrawLine(pen, 12 + dx, 13, 18 + dx, 7);
                        g.DrawLine(pen, 18 + dx, 7, 18 + dx, 20);
                        g.DrawLine(pen, 18 + dx, 20, 12 + dx, 14);
                    }
                }
                else
                {
                    int d = pushed ? 1 : 0;
                    Point[] pts = { new Point(12 + d + dx, 13 + d), new Point(18 + d + dx, 7 + d), 
                    new Point(18 + d + dx, 20 + d), new Point(12 + d + dx, 14 + d) };
                    g.FillPolygon(new SolidBrush(Color.FromArgb(0, 128, 00)), pts);
                    using (Pen pen = new Pen(Color.Black))
                    {
                        g.DrawLines(pen, pts);
                    }
                }
            }
        }
        //uOցv{^
        private void BtnPrev_Execute()
        {
            doPrevPage();
        }
        private void BtnPrev_Draw(Graphics g, bool pushed, bool enabled)
        {
            //Op`G
            if (!enabled)
            {
                Pen pen;
                using (pen = new Pen(Color.White))
                {
                    g.DrawLine(pen, 13, 14, 19, 8);
                    g.DrawLine(pen, 19, 8, 19, 20);
                }
                using (pen = new Pen(Color.FromArgb(128, 128, 128)))
                {
                    g.DrawLine(pen, 12, 13, 18, 7);
                    g.DrawLine(pen, 18, 7, 18, 20);
                    g.DrawLine(pen, 18, 20, 12, 14);
                }
            }
            else
            {
                int d = pushed ? 1 : 0;
                Point[] pts = { new Point(12 + d, 13 + d), new Point(18 + d, 7 + d), 
                    new Point(18 + d, 20 + d), new Point(12 + d, 14 + d) };
                g.FillPolygon(new SolidBrush(Color.FromArgb(0, 128, 00)), pts);
                using (Pen pen = new Pen(Color.Black))
                {
                    g.DrawLines(pen, pts);
                }
            }
        }
        //uցv{^
        private void BtnNext_Execute()
        {
            doNextPage();
        }
        private void BtnNext_Draw(Graphics g, bool pushed, bool enabled)
        {
            //Op`G
            if (!enabled)
            {
                Pen pen;
                using (pen = new Pen(Color.White))
                {
                    g.DrawLine(pen, 19, 14, 13, 8);
                    g.DrawLine(pen, 13, 8, 13, 20);
                    g.DrawLine(pen, 14, 20, 19, 15);
                }
                using (pen = new Pen(Color.FromArgb(128, 128, 128)))
                {
                    g.DrawLine(pen, 18, 13, 12, 7);
                    g.DrawLine(pen, 12, 7, 12, 20);
                    g.DrawLine(pen, 12, 20, 18, 14);
                }
            }
            else
            {
                int d = pushed ? 1 : 0;
                Point[] pts = { new Point(18 + d, 13 + d), new Point(12 + d, 7 + d), 
                    new Point(12 + d, 20 + d), new Point(18 + d, 14 + d) };
                g.FillPolygon(new SolidBrush(Color.FromArgb(0, 128, 00)), pts);
                using (Pen pen = new Pen(Color.Black))
                {
                    g.DrawLines(pen, pts);
                }
            }
        }
        //uŌցv{^
        private void BtnLast_Execute()
        {
            doLastPage();
        }
        private void BtnLast_Draw(Graphics g, bool pushed, bool enabled)
        {
            //Op`QG
            for (int k = 0; k < 2; k++)
            {
                int dx = k * 7 - 4;
                if (!enabled)
                {
                    Pen pen;
                    using (pen = new Pen(Color.White))
                    {
                        g.DrawLine(pen, 19 + dx, 14, 13 + dx, 8);
                        g.DrawLine(pen, 13 + dx, 8, 13 + dx, 20);
                        g.DrawLine(pen, 14 + dx, 20, 19 + dx, 15);
                    }
                    using (pen = new Pen(Color.FromArgb(128, 128, 128)))
                    {
                        g.DrawLine(pen, 18 + dx, 13, 12 + dx, 7);
                        g.DrawLine(pen, 12 + dx, 7, 12 + dx, 20);
                        g.DrawLine(pen, 12 + dx, 20, 18 + dx, 14);
                    }
                }
                else
                {
                    int d = pushed ? 1 : 0;
                    Point[] pts = { new Point(18 + d + dx, 13 + d), new Point(12 + d + dx, 7 + d), 
                    new Point(12 + d + dx, 20 + d), new Point(18 + d + dx, 14 + d) };
                    g.FillPolygon(new SolidBrush(Color.FromArgb(0, 128, 00)), pts);
                    using (Pen pen = new Pen(Color.Black))
                    {
                        g.DrawLines(pen, pts);
                    }
                }
            }
        }
        
        //Ctrl@L[
        private void SelectableForm_KeyDown(object sender, KeyEventArgs e)
        {
            //KeyCode + Modifiers = KeyData
            if ((e.Modifiers & Keys.Control) == Keys.Control)
            {
                if (e.KeyCode == Keys.Left)
                {
                    doPrevPage();
                }
                else if (e.KeyCode == Keys.Right)
                {
                    doNextPage();
                }
                else if (e.KeyCode == Keys.Up)
                {
                    doPrev10Page();
                }
                else if (e.KeyCode == Keys.Down)
                {
                    doNext10Page();
                }
            }

        }
        #endregion

    }//class
}//namespace
