/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Specialized;
using CWIDatas;
using System.IO;
using System.Resources;

namespace CWI.Dialog
{
    /// <summary>
    /// Description of TeamSelectDlg.
    /// </summary>
    public partial class TeamSelectDlg : CWI.Dialog.SelectableForm
    {

        public TeamSelectDlg(InnData inn)
        {
            InitializeComponent();
            SetUpPosition();
            this.BtnSelect.Text = "";
            this.BtnNew.Text = "VK";
            this.BtnCancel.Text = "~";
            this.Text = "p[eB[̑I";
            this.inn = inn;
        }

        private InnData inn;
        private int oldIndex = -1;
        private PartyIndexData[] datas;
        public PartyIndexData selectedParty;
        void TeamSelectDlgShown(object sender, System.EventArgs e)
        {
            index = 0;
            count = inn.Parties.Count;

            if (count == 0)
            {
                this.BtnSelect.Enabled = false;
            }
            else
            {
                datas = new PartyIndexData[count];
                PartyIndexData pid;
                int i = 0;
                foreach (PartyData pd in inn.Parties)
                {
                    pid = Util1.MakePartyIndexData(inn, pd);
                    datas[i++] = pid;
                }

                if (inn.CurrentParty == null)
                {
                    index = 0;
                }
                else
                {
                    index = inn.GetPartyIndex(inn.CurrentParty);
                    oldIndex = index;
                }

            }

            ShowPage();
        }


        protected override void ShowPage()
        {
            if (count == 0)
            {
                return;
            }

            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {
                //wi
                Bitmap book = (Bitmap)Image.FromFile(FilePath.GetBookFile());
                g.DrawImage(book, ViewPanel.ClientRectangle);
                book.Dispose();

                StringFormat format = new StringFormat();//VKtH[}bg
                format.Alignment = StringAlignment.Center;//

                //eLXg
                Font TextFont = new Font("lr o", 9, FontStyle.Bold);
                Rectangle rectText = new Rectangle(0, 24, this.ClientSize.Width, TextFont.Height);//͈͂̐ݒ
                g.DrawString("Adventurer's Team", TextFont, SolidBlack, rectText, format);//
                TextFont.Dispose();

                //p[eB
                Font largeFont = new Font("lr o", 12, FontStyle.Bold);
                Rectangle rectPartyName = new Rectangle(0, 40, this.ClientSize.Width, largeFont.Height);//͈͂̐ݒ
                g.DrawString(datas[index].PartyName, largeFont, SolidBlack, rectPartyName, format);//p[eB
                largeFont.Dispose();

                //
                Font TeamMoneyFont = new Font("lr o", 9, FontStyle.Bold);
                Rectangle rectTeamMoney = new Rectangle(0, 61, this.ClientSize.Width, TeamMoneyFont.Height);//͈͂̐ݒ
                g.DrawString("Money " + datas[index].Money + " sp", TeamMoneyFont, SolidBlack, rectTeamMoney, format);//
                TeamMoneyFont.Dispose();

                Font ScenarioNameFont = new Font("lr o", 11, FontStyle.Bold);
                Rectangle rectScenarioName = new Rectangle(0, 230, this.ClientSize.Width, ScenarioNameFont.Height);//͈͂̐ݒ
                g.DrawString(datas[index].PlayingScenarioName, ScenarioNameFont, SolidBlack, rectScenarioName, format);//ViI
                ScenarioNameFont.Dispose();

                if (datas[index].InScenario && !datas[index].ScenarioImage.empty)
                {
                    //ViI摜
                    g.DrawImage(datas[index].ScenarioImage.bitmap, ((this.Width - 74) / 2), 126);//摜
                }
                else if(datas[index].InScenario == false)
                {
                    //h摜
                    g.DrawImage(new ImageData(CWIEngine.Properties.Resources.CardMenu_Ŕ).bitmap,
                        ((this.Width - 74) / 2), 126);//摜

                }

                Font normalFont = new Font(FontFamily.GenericMonospace, 8, FontStyle.Bold);
                int cursolX = 120, cursolY = 80;
                foreach (string s in datas[index].Members)
                {
                    g.DrawString(s, normalFont, SolidBlack, cursolX, cursolY);
                    cursolX += 100;
                    //ʒuݒ
                    if (cursolX > 320)
                    {
                        cursolX = 120;
                        cursolY += 20;
                    }
                }
                normalFont.Dispose();

                Font smallFont = new Font("lr o", 9, FontStyle.Bold);//tHg
                Rectangle rectCount = new Rectangle(0, 253, this.ClientSize.Width, smallFont.Height);//͈͂̐ݒ
                g.DrawString((index + 1) + " / " + count, smallFont, SolidBlack, rectCount, format);//ViI̕`
                smallFont.Dispose();//tHg

                format.Dispose();//tH[}bg

            }
            ViewPanel.Invalidate();
        }
        protected override void doSelectPage()
        {

            //OCurrentPartỹp[eB̏t@CɔfĂ
            if (inn.CurrentParty != null 
                && index != oldIndex)
            {
                inn.SaveCurrentParty();
            }

            if (index != oldIndex)
            {
                // Jgp[eB[ύX
                inn.CurrentParty = inn.Parties[index];
                // Jgp[eB[̓t@CĂ͂Ȃ
                inn.DeletePartyFile(inn.CurrentParty);
            }

            this.DialogResult = DialogResult.OK;
        }

        private void BtnNew_Click(object sender, EventArgs e)
        {
            //OCurrentPartỹp[eB̏t@CɔfĂ
            if (inn.CurrentParty != null)
            {
                inn.SaveCurrentParty();
                // Jgp[eB[ύX
                inn.CurrentParty = null;

                this.DialogResult = DialogResult.OK;

            }

        }

    }//class
}//namespace
