﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace CWI
{
    public class UnchangeColoredTextBox : TextBox
    {

        protected override void OnEnabledChanged(EventArgs e)
        {
            base.OnEnabledChanged(e);
            //EnabledがFalseの時だけ自分で描画する
            if (this.Enabled)
                this.SetStyle(System.Windows.Forms.ControlStyles.UserPaint, false);
            else
                this.SetStyle(System.Windows.Forms.ControlStyles.UserPaint, true);
            //再描画
            this.Invalidate();
        }

        //TextBoxを描画する
        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            base.OnPaint(e);
            System.Drawing.Brush b =
                new System.Drawing.SolidBrush(this.ForeColor);
            //文字列を描画する
            e.Graphics.DrawString(this.Text, this.Font, b, -1, 1);
            b.Dispose();
        }
    }
    
}
