using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Specialized;
using CWI;
using System.IO;
using System.Resources;
using System.Linq;
using System.Collections.Generic;

namespace CWI.Dialog
{
    /// <summary>
    /// Description of YadoSelectDlg.
    /// </summary>
    public partial class YadoSelectDlg : SelectableForm
    {

        private string oldYadoName = string.Empty; 

        private YadoSelectData[] datas;

        public YadoSelectData SelectedYado;

        private Form _owner;

        public YadoSelectDlg(Form owner)
        {
            ConstructMethod();

            _owner = owner;
            this.StartPosition = FormStartPosition.Manual;
            this.Left =
            _owner.Left + (_owner.Width - this.Width) / 2;
            this.Top =
                _owner.Top + (_owner.Height - this.Height) / 2;
        }

        public YadoSelectDlg()
        {
            ConstructMethod();
        }

        public YadoSelectDlg(Form owner,string oldYadoName)
        {
            // I
            this.oldYadoName = oldYadoName;

            ConstructMethod();

            _owner = owner;
            this.StartPosition = FormStartPosition.Manual;
            this.Left =
            _owner.Left + (_owner.Width - this.Width) / 2;
            this.Top =
                _owner.Top + (_owner.Height - this.Height) / 2;
        }

        private void ConstructMethod() {

            InitializeComponent();
            SetUpPosition();
            BtnSelect.Text = "";
            BtnCancel.Text = "~";
            BtnDelete.Text = "폜";
            BtnNew.Text = "VK";
            this.Text = "h̑I";


            index = 0;
            count = 0;
            string[] split;
            string strDir;

            foreach (string folder in Directory.GetDirectories(FilePath.GetSystemYadoFolder()))
            {
                split = folder.Split('\\');
                strDir = split[split.Length - 1];
                if (strDir.Length != 0 && !strDir.StartsWith("~"))
                {
                    if (File.Exists(FilePath.GetYadoEnvironmentFile(folder)))
                    {
                        count++;
                    }
                }
            }

            if (count == 0)
            {
                BtnSelect.Enabled = false;
                BtnDelete.Enabled = false;
                return;
            }
            datas = new YadoSelectData[count];

            foreach (string folder in Directory.GetDirectories(FilePath.GetSystemYadoFolder()))
            {
                split = folder.Split('\\');
                strDir = split[split.Length - 1];
                if (strDir.Length != 0
                    && !strDir.StartsWith("~"))
                {
                    string file = FilePath.GetYadoEnvironmentFile(folder);
                    if (File.Exists(file))
                    {
                        YadoSelectData yado = new YadoSelectData(folder);
                        datas[index] = yado;

                        index++;
                    }
                }
            }

            if(index > 0)
                datas = datas.OrderByDescending(dateTime => dateTime.LastAccessTime).ToArray();
        }



        void YadoSelectDlgShown(object sender, System.EventArgs e)
        {

            index = 0;

            // }EXEJ[\̈ʒuNCAgɈړ
            Cursor.Position = new Point(this.Location.X + this.Width / 2, this.Location.Y + this.Height / 2); 

            ShowPage();

        }

        protected override void ShowPage()
        {
            /*
             * t004m004
            */
            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {//\Ƃ
                Bitmap bill = (Bitmap)Image.FromFile(FilePath.GetBillFile());//wi̐ݒ
                g.DrawImage(bill, ViewPanel.ClientRectangle);//wi`
                bill.Dispose();//摜̉

                if (count == 0)
                {
                    BtnSelect.Enabled = false;
                    BtnDelete.Enabled = false;

                    ViewPanel.Invalidate();
                    return;
                }
                else
                {
                    BtnSelect.Enabled = true;
                    BtnDelete.Enabled = true;
                }

                StringFormat format = new StringFormat();//VKtH[}bg
                format.Alignment = StringAlignment.Center;//

                Font big = new Font("lr o", 16, FontStyle.Bold);//tHg̐ݒ
                Rectangle rectYadoName = new Rectangle(0, 36, this.ClientSize.Width, big.Height);//͈͂̐ݒ
                g.DrawString(datas[index].Name, big, SolidBlack, rectYadoName, format);//h̕`
                big.Dispose();//tHg̉

                g.DrawImage(datas[index].Img, 163, 70);//h摜̕`

                //o[̕`
                Font MemberFont = new Font("lr o", 9, FontStyle.Bold);
                Rectangle rectMember = new Rectangle(0, 170, this.ClientSize.Width, MemberFont.Height);//͈͂̐ݒ
                g.DrawString("Adventurers", MemberFont, SolidBlack, rectMember, format);
                MemberFont.Dispose();//tHg

                Font normalFont = new Font(FontFamily.GenericMonospace, 8, FontStyle.Bold);
                int cursolX = 70, cursolY = 200; int i = 0;//WAWAJE^
                foreach (string s in datas[index].Members)
                {
                    // t005+ 
                    i++;//JE^
                    if ((i == 24) && (datas[index].Members.Count > 24))
                    {//AJE^QSŃo[QSl葽
                        g.DrawString("̑...", normalFont, SolidBlack, cursolX, cursolY);
                        break;//
                    }

                    g.DrawString(s, normalFont, SolidBlack, cursolX, cursolY);//o[̕\

                    //ʒu炷
                    cursolX += 100;
                    if (cursolX > 270)
                    {
                        cursolX = 70;
                        cursolY += 17;
                    }

                    //܂
                }
                normalFont.Dispose();//tHg̉

                //JEg
                Font smallFont = new Font("lr o", 9, FontStyle.Bold);//tHg
                Rectangle rectCount = new Rectangle(0, 340, this.ClientSize.Width, smallFont.Height);//͈͂̐ݒ
                g.DrawString((index + 1) + "/" + count, smallFont, SolidBlack, rectCount, format);//yado̕`
                smallFont.Dispose();//tHg

                format.Dispose();//tH[}bg

                //܂
            }


            ViewPanel.Invalidate();

        }
        protected override void doSelectPage()
        {
            if (this.oldYadoName != string.Empty && this.oldYadoName == datas[index].Name)
            {
                MessageDlg.ShowInfoDialog(
                   "݂ƓhłB");
                return;
            }

            SelectedYado = datas[index];
            this.DialogResult = DialogResult.OK;
        }

        private void YadoSelectDlg_Load(object sender, EventArgs e)
        {

            ////// }EXEJ[\̈ʒuXN[Ɉړ
            ////int centerX = Screen.PrimaryScreen.Bounds.Right / 2;
            ////int centerY = Screen.PrimaryScreen.Bounds.Bottom / 2;
            ////Point cursolPosition = new Point(centerX, centerY);
            ////this.Location = new Point(centerX - this.Width / 2, centerY - this.Height / 2);

        }

        private void BtnNew_Click(object sender, EventArgs e)
        {
            DialogResult res = DialogResult.Abort;
            if(datas == null)
            {
                datas = new YadoSelectData[0];
            }
            NewInnDlg form = new NewInnDlg(datas);
            res = form.ShowDialog();
            if (res == DialogResult.OK)
            {
                datas = form.datas;
                index = 0;
                count++;
                ShowPage();
            }
        }

        private void BtnDelete_Click(object sender, EventArgs e)
        {
            DialogResult res = DialogResult.No;
            res = MessageDlg.ShowYesNoDialog("hu" + datas[index].Name + "vj܂B낵łH");
            if (res == DialogResult.Yes)
            {   //OłȂƂł\
                FilePath.DeleteFolder(datas[index].TempFolder);
                FilePath.DeleteFolder(datas[index].Folder);
                List<YadoSelectData> lst = new List<YadoSelectData>(datas);
                lst.RemoveAt(index);
                datas = lst.ToArray();
                count--;
                if(count == index)
                {
                    index = count - 1;
                }
                ShowPage();
            }
        }
    }//class YadoSelectDlg

}//namespace
