﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

using CWI.Dialog;
using CWIDatas;
using CWI.Card;

namespace CWI
{
    public partial class DispCard : UserControl
    {
        // HandCard DispCardのサイズ
        private const int HAND_CARD_WIDTH = 80;
        private const int HAND_CARD_HEIGHT = 110;
        private Size HC_SIZE = new Size(HAND_CARD_WIDTH, HAND_CARD_HEIGHT);

        private Image ViewBitmap;
        public CharacterData cd;
        public HandCard hc;

        public DispCard()
        {
            InitializeComponent();
        }

        public DispCard(CharacterData cd)
        {
            InitializeComponent();

            SetCd(cd);
        }

        public void SetCd(CharacterData cd)
        {
            this.cd = cd;
           
            // ただPictureBoxに設定していたが、範囲表示するためDrawRectangle
            // this.pictureBox1.Image = cd.Image.bitmap;

            if (this.pictureBox1.Image != null)
            {
                this.pictureBox1.Image.Dispose();
            }
            this.pictureBox1.Image = null;
            ViewBitmap = new Bitmap(this.pictureBox1.Width, this.pictureBox1.Height);
            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {
                g.DrawRectangle(new Pen(Color.Orange)
                    , new Rectangle(0, 0, this.pictureBox1.Width - 1, this.pictureBox1.Height - 1));

                if (cd.Image.bitmap != null)
                {
                    //g.DrawImage(cd.Image.bitmap, 5, 2);

                    ////// グリュエルで女の子を出す場合
                    ////g.DrawImage(cd.Image.bitmap,
                    ////    // ViewPanel内の表示位置
                    ////    new Rectangle(5, 2,
                    ////        CWData.Bitmap_Width, CWData.Bitmap_Height),
                    ////    new Rectangle(0, 0,
                    ////        CWData.Bitmap_Width, CWData.Bitmap_Height),
                    ////    GraphicsUnit.Pixel);

                    // グリュエルで大熊猫を出す場合
                    g.DrawImage(cd.Image.bitmap,
                        // ViewPanel内の表示位置
                        new Rectangle(5, 2,
                            CWData.Bitmap_Width, CWData.Bitmap_Height),
                        new Rectangle(cd.Image.bitmap.Width / 2 - CWData.Bitmap_Width / 2,
                            cd.Image.bitmap.Height / 2 - CWData.Bitmap_Height / 2,
                            CWData.Bitmap_Width, CWData.Bitmap_Height),
                        GraphicsUnit.Pixel);

                    ////// グリュエルで女の子（裸）を出す場合
                    ////g.DrawImage(cd.Image.bitmap,
                    ////    // ViewPanel内の表示位置
                    ////    new Rectangle(5, 2,
                    ////        CWData.Bitmap_Width, CWData.Bitmap_Height),
                    ////    new Rectangle(cd.Image.bitmap.Width / 2 - CWData.Bitmap_Width / 2,
                    ////        cd.Image.bitmap.Height - CWData.Bitmap_Height,
                    ////        CWData.Bitmap_Width, CWData.Bitmap_Height),
                    ////    GraphicsUnit.Pixel);


                }
            }

            this.pictureBox1.Invalidate();
            this.lblName.Text = cd.CardName;
            this.lblLevel.Text = cd.Level.ToString();

            string sex = "";//性別 Male or Female
            string age = "";//世代 Child or Young or Adult or Old
            string ep = "0";// EP 
            string type = "";//素質型
            List<String> coupNames = new List<string>();

            foreach (CouponData coup in cd.Coupons)
            {//クーポン繰り返し
                string s = coup.Name;
                if (!Regex.IsMatch(s, "(＿|＠)"))
                {//sに　＠か＿が含まれてなかったら
                    coupNames.Add(s);
                }
                else
                {//＠＆＿だけ判断
                    //見たままです
                    if (s.Equals(CWData.STR_MALE)) { sex = "♂"; }
                    if (s.Equals(CWData.STR_FEMALE)) { sex = "♀"; }
                    if (s.Equals(CWData.STR_CHILD)) { age = "子供"; }
                    if (s.Equals(CWData.STR_YOUNG)) { age = "若者"; }
                    if (s.Equals(CWData.STR_ADULT)) { age = "大人"; }
                    if (s.Equals(CWData.STR_OLD)) { age = "老人"; }
                    if (s.Equals(CWData.TYPE_NORMAL)) { type = CWData.DISP_NORMAL; }
                    if (s.Equals(CWData.TYPE_ALLMIGHTY)) { type = CWData.DISP_ALLMIGHTY; }
                    if (s.Equals(CWData.TYPE_RESOURCEFUL)) { type = CWData.DISP_RESOURCEFUL; }
                    if (s.Equals(CWData.TYPE_BRAVE)) { type = CWData.DISP_BRAVE; }
                    if (s.Equals(CWData.TYPE_DARING)) { type = CWData.DISP_DARING; }
                    if (s.Equals(CWData.TYPE_TACTIC)) { type = CWData.DISP_TACTIC; }
                    if (s.Equals(CWData.TYPE_BRILLIANT)) { type = CWData.DISP_BRILLIANT; }
                    if (s.Equals(CWData.TYPE_MATCHLESS)) { type = CWData.DISP_MATCHLESS; }
                    if (s.Equals(CWData.TYPE_GENIUS)) { type = CWData.DISP_GENIUS; }
                    if (s.Equals(CWData.TYPE_ORDINARY)) { type = CWData.DISP_ORDINARY; }
                    if (s.Equals(CWData.TYPE_HERO)) { type = CWData.DISP_HERO; }
                    if (s.Equals(CWData.TYPE_GOD)) { type = CWData.DISP_GOD; }
                    if (s.Equals(CWData.STR_EP)) { ep = coup.Point.ToString(); }
                }
            }

            this.lblAge.Text = age;
            this.lblType.Text = type;
            this.lblSex.Text = sex;
        }

        public DispCard(HandCard hc)
        {
            InitializeComponent();
            SetHc(hc);
        }

        public void SetHc(HandCard hc)
        {
            this.hc = hc;

            this.lblName.Visible = false;
            this.lblType.Visible = false;
            this.lblAge.Visible = false;
            this.lblSex.Visible = false;

            if (this.pictureBox1.Image != null)
            {
                this.pictureBox1.Image.Dispose();
            }
            this.pictureBox1.Image = null;

            ViewBitmap = new Bitmap(HC_SIZE.Width, HC_SIZE.Height);
            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {
                if (hc.CardImage != null)
                {
                    g.DrawImage(hc.CardImage, 0, 0);
                }
                if (hc.CardDecoImage != null)
                {
                    g.DrawImage(hc.CardDecoImage, 0, 0);
                }
            }

            this.Size = HC_SIZE;
            this.pictureBox1.Size = HC_SIZE;

            this.pictureBox1.Invalidate();
            
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {

            if (ViewBitmap != null)
                e.Graphics.DrawImage(ViewBitmap, this.pictureBox1.Location);
        }

    }
}
