
using System;
using System.Collections.Specialized;
using System.Collections.Generic;
using CWIDatas;
using System.IO;

namespace CWI
{
    public class SimpleSummaryData : DataWithIO
    {
        
        #region tB[h
        string scenario;
        string expression;
        string author;
        StringCollection needCoupon;
        uint needCouponCount;
        uint areaANDversion;

        uint levelLow;
        uint levelHigh;
        #endregion

        #region vpeB

        public string ScenarioName
        {
            get { return scenario; }
            set { scenario = value; }
        }
        public string ScenarioExpression
        {
            get { return expression; }
            set { expression = value; }
        }
        public string Author
        {
            get { return author; }
            set { author = value; }
        }
        public StringCollection NeedCoupons
        {
            get
            {
                if (needCoupon == null)
                    needCoupon = new StringCollection();
                return needCoupon;
            }
        }
        public uint NeedCouponCount
        {
            get { return needCouponCount; }
            set { needCouponCount = value; }
        }

        public uint Version
        {
            get { return areaANDversion / CWData.VersionOffset; }
            set { areaANDversion = AreaNumber + value * CWData.VersionOffset; }
        }

        public uint AreaNumber
        {
            get { return areaANDversion % CWData.VersionOffset; }
            set { areaANDversion = value + Version * CWData.VersionOffset; }
        }

        public uint LevelLow
        {
            get { return levelLow; }
            set { levelLow = value; }
        }
        public uint LevelHigh
        {
            get { return levelHigh; }
            set { levelHigh = value; }
        }
        #endregion

        public SimpleSummaryData() {  }

        #region [hCg
        public override void Read(System.IO.BinaryReader r)
        {
            Stream stream = r.BaseStream;
            //image
            //image.Read(r);
            int size = r.ReadInt32();
            if (size != 0) stream.Seek(size, SeekOrigin.Current);

            scenario = r.ReadString();

            expression = ((SjisCBinaryReader)r).ReadStringCRLF();

            author = r.ReadString();
            
            needCoupon = ((SjisCBinaryReader)r).ReadStringCollection();
            needCouponCount = r.ReadUInt32();

            areaANDversion = r.ReadUInt32();

            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                // StepIndexData
                //name = r.ReadString();
                size = r.ReadInt32();
                if (size != 0) stream.Seek(size, SeekOrigin.Current);

                //initial = r.ReadUInt32();
                stream.Seek(4, SeekOrigin.Current);

                for (int k = 0; k <= 9; k++)
                {
                    //    values[k] = r.ReadString();
                    size = r.ReadInt32();
                    if (size != 0) stream.Seek(size, SeekOrigin.Current);
                }
            }

            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                // FlagIndexData 
                //name = r.ReadString();
                size = r.ReadInt32();
                if (size != 0) stream.Seek(size, SeekOrigin.Current);
                //initial = r.ReadByte();
                stream.Seek(1, SeekOrigin.Current);

                for (int k = 1; k >= 0; k--)
                {
                    //    values[k] = r.ReadString();
                    size = r.ReadInt32();
                    if (size != 0) stream.Seek(size, SeekOrigin.Current);
                }
            }

            //nazo0
            //nazo0 = r.ReadInt32();
            stream.Seek(4, SeekOrigin.Current);

            if (r.PeekChar() != -1)
            {
                levelLow = r.ReadUInt32();
                levelHigh = r.ReadUInt32();
            }
  
        }
        public override void Write(System.IO.BinaryWriter w)
        {

        }
        #endregion
    }
}
