
using System;
using System.Resources;
using System.Drawing;
using System.IO;
using System.Text.RegularExpressions;

namespace CWI
{
    /// <summary>
    /// Description of FileAndPath.
    /// tH_^̕ϐ̕\`́AtpX{Ō\͂ȂƑz肵Ă
    /// </summary>
    public static class FilePath
    {

        static System.Reflection.Assembly curasm = null;
        static System.Resources.ResourceManager rm = null;

        public static string SystemYadoFolderName = "Yado";
        public static string SystemScenarioFolderName = "Scenario";

        public static string SystemDataFolderName = "Data";
        static string SystemDataTableFolderName = SystemDataFolderName + "\\Table";
        static string SystemDataMidiFolderName = SystemDataFolderName + "\\Midi";
        static string SystemDataWaveFolderName = SystemDataFolderName + "\\Wave";
        static string SystemDataFaceFolderName = SystemDataFolderName + "\\Face";

        static string SystemTempFolderName = "Temp";

        public static readonly string Environment_wyd = "Environment.wyd";
        static readonly string Summary_wsm = "Summary.wsm";
        public static readonly string ExtPartyData = ".wpt";
        public static readonly string ExtIndexPartyData = ".wpl";
        static readonly string ExtAlbumCharacterData = ".wrm";
        public static readonly string ExtCharacterData = ".wcp";
        public static readonly string ExtIndexCharacterData = ".wch";
        public static readonly string ExtBitmap = ".bmp";
        public static readonly string ExtPng = ".png";
        static readonly string ExtWidData = ".wid";
        static readonly string YadoImage = "AdventurersInn.bmp";
        static readonly string MapWirth = "MapOfWirth.bmp";
        static readonly string Billbmp = "Bill.bmp";
        static readonly string Bookbmp = "Book.bmp";
        static readonly string GameOverbmp = "GameOver.bmp";
        static readonly string Logobmp = "Logo.bmp";
        static readonly string DefInn = "DefInn.mid";
        static readonly string DefOpen = "DefOpen.mid";
        static readonly string DefOver = "DefOver.mid";
        static readonly string BeyonedMyHeart = "BeyonedMyHeart.mid";
        static readonly string WaveClick = "VXeENbN.wav";
        static readonly string WavePage = "VXeEy[W.wav";
        static readonly string WaveBattle = "VXeE퓬.wav";
        static readonly string WaveConfuse = "ʁij.wav";
        static readonly string WaveInvalid = "VXeE.wav";
        static readonly string WaveEvade = "VXeE.wav";
        static readonly string WaveGet = "VXeEn.wav";
        static readonly string WaveEquip = "VXeE.wav";

        public static readonly string MaskPartyData = "*" + ExtPartyData;
        public static readonly string MaskIndexPartyData = "*" + ExtIndexPartyData;
        public static readonly string MaskAlbumCharacterData = "*" + ExtAlbumCharacterData;
        public static readonly string MaskIndexCharacterData = "*" + ExtIndexCharacterData;
        public static readonly string MaskCharacterData = "*" + ExtCharacterData;
        public static readonly string MaskBitmap = "*.bmp";
        public static readonly string MaskPng = "*.png";
        public static readonly string MaskGif = "*.gif";
        public static string ApplicationFolder;
        public static string TempYadoSymbol = "~";
        public static string BackupYadoSymbol = "_";

        public static string VariantExe = ".\\CardWirth.exe";

        /// <summary>
        /// CWœFɗǂgR=255,G=0,B=255̐F
        /// </summary>
        public static Color CWTransparentColor = Color.FromArgb(255, 0, 255);

        public static string PartyInitialNameEnd = "s";

        // fobNCardWirthtH_̃tpXw
        public static readonly string CW_PATH = @"C:\CardWirth_AP";
        //public static readonly string CW_PATH = @"C:\CardWirth";
        //public static readonly string CW_PATH = @"C:\CardWirth\1.5.0.1";

        static FilePath()
        {
            curasm = System.Reflection.Assembly.GetExecutingAssembly();
            rm =
            new System.Resources.ResourceManager(
                "CWIEngine.Properties.Resources", curasm);

        }

        public static string GetTextStream(string resourceName)
        {
            object obj = rm.GetObject(resourceName);

            return (string)obj;
        }

        public static byte[] GetFileResource(string resourceName)
        {
            return (byte[])rm.GetObject(resourceName);
        }

        public static void SetApplicationFolder(string str)
        {
            ApplicationFolder = str;
        }

        public static void SetDataFolderName(string dataFolderName)
        {
            SystemDataFolderName = dataFolderName;
            SystemDataTableFolderName = SystemDataFolderName + "\\Table";
            SystemDataMidiFolderName = SystemDataFolderName + "\\Midi";
            SystemDataWaveFolderName = SystemDataFolderName + "\\Wave";
            SystemDataFaceFolderName = SystemDataFolderName + "\\Face";
        }

        #region VXetH_/t@C̃pX
        /// <summary>
        /// "CardWirth\Yado"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetSystemYadoFolder()
        {
            return ApplicationFolder + "\\" + SystemYadoFolderName;
        }

        /// <summary>
        /// "CardWirth\Scenario"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetSystemScenarioFolder()
        {
            return ApplicationFolder + "\\" + SystemScenarioFolderName;
        }

        public static bool CheckScenaFolder(string folderPath)
        {
            return GetSystemScenarioFolder() == Path.GetDirectoryName(folderPath);
        }

        /// <summary>
        /// "CardWirth\Data"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetSystemDataFolder()
        {
            return ApplicationFolder + "\\" + SystemDataFolderName;
        }

        /// <summary>
        /// "CardWirth\Data\Table"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetDataTableFolder()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName;
        }
        /// <summary>
        /// "CardWirth\Data\Wave"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetDataWaveFolder()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName;
        }
        /// <summary>
        /// "CardWirth\Data\Midi"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetDataMidiFolder()
        {
            return ApplicationFolder + "\\" + SystemDataMidiFolderName;
        }
        /// <summary>
        /// "CardWirth\Data\Table\AdventurersInn.bmp"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetYadoImageFile()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName + "\\" + YadoImage;
        }
        /// <summary>
        /// "CardWirth\Data\Table\MapOfWirth.bmp"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWirthMapFile()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName + "\\" + MapWirth;
        }
        /// <summary>
        /// "CardWirth\Data\Table\Bill.bmp"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetBillFile()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName + "\\" + Billbmp;
        }
        /// <summary>
        /// "CardWirth\Data\Table\Book.bmp"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetBookFile()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName + "\\" + Bookbmp;
        }
        /// <summary>
        /// "CardWirth\Data\Table\GameOver.bmp"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetGameOverImageFile()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName + "\\" + GameOverbmp;
        }
        /// <summary>
        /// "CardWirth\Data\Table\Logo.bmp"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetLogoFile()
        {
            return ApplicationFolder + "\\" + SystemDataTableFolderName + "\\" + Logobmp;
        }

        /// <summary>
        /// "CardWirth\Data\Midi\DefInn.mid"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetDefInnMidi()
        {
            return ApplicationFolder + "\\" + SystemDataMidiFolderName + "\\" + DefInn;
        }
        /// <summary>
        /// "CardWirth\Data\Midi\DefOpen.mid"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetDefOpenMidi()
        {
            return ApplicationFolder + "\\" + SystemDataMidiFolderName + "\\" + DefOpen;
        }
        /// <summary>
        /// "CardWirth\Data\Midi\DefOver.mid"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetDefOverMidi()
        {
            return ApplicationFolder + "\\" + SystemDataMidiFolderName + "\\" + DefOver;
        }
        /// <summary>
        /// "CardWirth\Data\Midi\BeyonedMyHeart.mid"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetBeyonedMyHeartMidi()
        {
            return ApplicationFolder + "\\" + SystemDataMidiFolderName + "\\" + BeyonedMyHeart;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeENbN.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveClick()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveClick;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeEy[W.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWavePage()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WavePage;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeE퓬.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveBattle()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveBattle;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\ʁij.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveConfuse()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveConfuse;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeE.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveInvalid()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveInvalid;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeE.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveEvade()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveEvade;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeEn.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveGet()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveGet;
        }
        /// <summary>
        /// "CardWirth\Data\Wave\VXeE.wav"t@C
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetWaveEquip()
        {
            return ApplicationFolder + "\\" + SystemDataWaveFolderName + "\\" + WaveEquip;
        }


        /// <summary>
        /// "CardWirth\Temp"tH_
        /// </summary>
        /// <returns>tpX</returns>
        public static string GetSystemTempFolder()
        {
            return ApplicationFolder + "\\" + SystemTempFolderName;
        }

        /// <summary>
        /// "CardWirth\Data\Face\*.bmp"
        /// </summary>
        /// <param name="sex"></param>
        /// <param name="age">N</param>
        /// <returns>tpX</returns>
        public static string GetDataFaceFolder(Sex sex, Age age)
        {
            string folder = string.Empty;
            folder += ApplicationFolder + "\\" + SystemDataFaceFolderName + "\\" + sex.ToString() ;
            switch (age)
            {
                case Age.Child:
                    folder += "-" + "CHD";
                    break;
                case Age.Young:
                    folder += "-" + "YNG";
                    break;
                case Age.Adult:
                    folder += "-" + "ADT";
                    break;
                case Age.Old:
                    folder += "-" + "OLD";
                    break;
                default:
                    break;
            }

            //CommontH_Ȃ̂CreateDirectory
            if (Directory.Exists(folder) == false)
            {
                Directory.CreateDirectory(folder);
            }

            return folder;
        }

        /// <summary>
        /// "CardWirth\Data\Face\*.bmp"
        /// </summary>
        /// <param name="sexAgeFolder">ʔN</param>
        /// <returns>tpX</returns>
        public static string GetDataFaceFolder(string sexAgeFolder)
        {
            string folder = ApplicationFolder + "\\" + SystemDataFaceFolderName +
                "\\" + sexAgeFolder;

            //CommontH_Ȃ̂CreateDirectory
            if (Directory.Exists(folder) == false)
            {
                Directory.CreateDirectory(folder);
            }

            return folder;
        }
        #endregion

        #region YadõtH_/t@C̃pX
        /// <summary>
        /// "CardWirth\Yado\h\Environment.wyd"t@C
        /// </summary>
        /// <param name="yadoFolder">h̃tpX</param>
        /// <returns>tpX</returns>
        public static string GetYadoEnvironmentFile(string yadoFolder)
        {
            return yadoFolder + "\\" + Environment_wyd;
        }
        /// <summary>
        /// "CardWirth\Yado\h\NXs.wpt"t@C
        /// </summary>
        /// <param name="yadoFolder">h̃tpX</param>
        /// <param name="party">p[eB</param>
        /// <returns>tpX</returns>
        public static string GetPartyFile(string yadoFolder, string party)
        {
            return yadoFolder + "\\" + party + ExtPartyData;
        }
        /// <summary>
        /// "CardWirth\Yado\h\NXs.wpl"t@C
        /// </summary>
        /// <param name="yadoFolder">h̃tpX</param>
        /// <param name="party">p[eB</param>
        /// <returns>tpX</returns>
        public static string GetIndexPartyFile(string yadoFolder, string party)
        {
            return yadoFolder + "\\" + party + ExtIndexPartyData;
        }
        /// <summary>
        /// "CardWirth\Yado\h\``.wid"t@C
        /// </summary>
        /// <param name="yadoFolder">h̃tpX</param>
        /// <param name="widName">p[eB</param>
        /// <returns>tpX</returns>
        public static string GetYadoWidFile(string yadoFolder, string widName)
        {
            return yadoFolder + "\\" + widName + ExtWidData;
        }
        /// <summary>
        /// "CardWirth\Yado\~h"tH_
        /// </summary>
        /// <param name="yadoName">h̖Ô</param>
        /// <returns>tpX</returns>
        public static string GetYadoTempFolder(string yadoName)
        {
            return GetSystemYadoFolder() + "\\" + TempYadoSymbol + yadoName;
        }
        /// <summary>
        /// "CardWirth\Yado\_h"tH_(obNAbvtH_)
        /// </summary>
        /// <param name="yadoName">h̖Ô</param>
        /// <returns>tpX</returns>
        public static string GetYadoBackupFolder(string yadoName)
        {
            return GetSystemYadoFolder() + "\\" + BackupYadoSymbol + yadoName;
        }

        

        #endregion

        #region ԍewidt@C𓾂郋[`
        public static string FileArea(uint num)
        {
            return "Area" + num.ToString() + ".wid";
        }
        public static string FileBattle(uint num)
        {
            return "Battle" + num.ToString() + ".wid";
        }
        public static string FilePackage(uint num)
        {
            return "Package" + num.ToString() + ".wid";
        }
        public static string FileItem(uint num)
        {
            return "Item" + num.ToString() + ".wid";
        }
        public static string FileSkill(uint num)
        {
            return "Skill" + num.ToString() + ".wid";
        }
        public static string FileBeast(uint num)
        {
            return "Beast" + num.ToString() + ".wid";
        }
        public static string FileMate(uint num)
        {
            return "Mate" + num.ToString() + ".wid";
        }
        public static string FileInfo(uint num)
        {
            return "Info" + num.ToString() + ".wid";
        }

        #endregion

        #region ScenariotH_̃t@C
        /// <summary>
        /// "CardWirth\Scenario\ViI\Summary.wsm"t@C
        /// </summary>
        /// <param name="yadoFolder">h̃tpX</param>
        /// <returns>tpX</returns>
        public static string GetSummaryFile(string scenarioFolder)
        {
            return scenarioFolder + "\\" + Summary_wsm;
        }

        /// <summary>
        /// "CardWirth\Scenario\"tH_
        /// </summary>
        /// <returns></returns>
        public static string GetScenarioFolder()
        {
            return ApplicationFolder + "\\" + SystemScenarioFolderName;
        }
        #endregion

        /// <summary>
        /// pX\t@CitH_jo[`
        /// </summary>
        /// <param name="fullpath"></param>
        /// <returns></returns>
        public static string FileNameFromPath(string fullpath)
        {
            return fullpath.Substring(fullpath.LastIndexOf('\\') + 1);
        }

        #region hƉו܃J[h֘A
        /// <summary>
        /// tH_\J[h.wid Ԃ
        /// </summary>
        /// <param name="folder">tH_</param>
        /// <param name="cardname">J[h</param>
        /// <returns></returns>
        public static string GetNameWithWid(string folder, string cardname)
        {
            return folder + "\\" + cardname + ".wid";
        }

        /// <summary>
        /// hɃJ[hۑۂɁAOɂȂȂ悤Ƀl[OԂB
        /// </summary>
        /// <param name="folder">Z[u悤ƂtH_[itpXj</param>
        /// <param name="cardname">Z[uJ[h̃J[h</param>
        /// <returns>l[J[hiJ[ĥ݁j</returns>
        public static string GetRenamedCardName(string folder, string cardname)
        {
            string basename = cardname;
            string tempname = cardname;
            uint num = 1;

            if (isProhibition(tempname))
            {
                basename = "Card";
                tempname = "Card";
            }


            while(File.Exists(folder + "\\" + tempname + ".wid"))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return tempname;
        }
        #endregion

        #region l[t@C擾

        internal static string GetBmpFileName(string faceFolder, string name)
        {
            string basename = name;
            string tempname = name;
            uint num = 1;

            if (isProhibition(tempname))
            {
                basename = "Pc";
                tempname = "Pc";
            }

            while (File.Exists(faceFolder + "\\" + tempname + ExtBitmap))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return faceFolder + "\\" + tempname + ExtBitmap;
        }

        /// <summary>
        /// LN^[innFolder̃tH_ɕۑ鎞Ɏgt@CԂB
        /// l[L
        /// </summary>
        /// <param name="innFolder">ۑtH_ʒu</param>
        /// <param name="name">LN^[</param>
        /// <returns>ۑt@C</returns>
        public static string GetCharacterFileName(string innFolder, string name)
        {
            string basename = name;
            string tempname = name;
            uint num = 1;

            if (isProhibition(tempname))
            {
                basename = "Member";
                tempname = "Member";
            }

            while (File.Exists(innFolder + "\\" + tempname + ExtCharacterData))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return innFolder + "\\" + tempname + ExtCharacterData;
        }

        internal static string GetIndexCharacterFileName(string innFolder, string name)
        {
            string basename = name;
            string tempname = name;
            uint num = 1;

            if (isProhibition(tempname))
            {
                basename = "Member";
                tempname = "Member";
            }

            while (File.Exists(innFolder + "\\" + tempname + ExtIndexCharacterData))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return innFolder + "\\" + tempname + ExtIndexCharacterData;
        }

        /// <summary>
        /// p[eB[innFolder̃tH_ɕۑ鎞Ɏgt@CԂB
        /// l[L
        /// </summary>
        /// <param name="innFolder">ۑtH_ʒu</param>
        /// <param name="name">p[eB[</param>
        /// <returns>ۑt@C</returns>
        public static string GetPartyFileName(string innFolder, string name)
        {
            string basename = name;
            string tempname = name;
            uint num = 1;
            
            if (isProhibition(tempname))
            {
                basename = "Party";
                tempname = "Party";
            }

            while (File.Exists(innFolder + "\\" + tempname + ExtPartyData))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return innFolder + "\\" + tempname + ExtPartyData;
        }

        /// <summary>
        /// AoLN^[innFolder̃tH_ɕۑ鎞Ɏgt@CԂB
        /// l[L
        /// </summary>
        /// <param name="innFolder">ۑtH_ʒu</param>
        /// <param name="name">LN^[</param>
        /// <returns>ۑt@C</returns>
        public static string GetAlbumFileName(string innFolder, string name)
        {
            string basename = name;
            string tempname = name;
            uint num = 1;
            if (isProhibition(tempname))
            {
                basename = "Retire";
                tempname = "Retire";
            }

            while (File.Exists(innFolder + "\\" + tempname + ExtAlbumCharacterData))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return innFolder + "\\" + tempname + ExtAlbumCharacterData;
        }

        /// <summary>
        /// WidCardinnFolder̃tH_ɕۑ鎞Ɏgt@CԂB
        /// l[L
        /// </summary>
        /// <param name="type">J[h^Cv</param>
        /// <param name="innFolder">ۑtH_ʒu</param>
        /// <param name="name">J[h</param>
        /// <returns>ۑt@C</returns>
        public static string GetWidFileName(CWIDatas.WidIDtype type,
            string innFolder, string name)
        {
            string basename = name;
            string tempname = name;
            uint num = 1;
            if (isProhibition(tempname))
            {
                if (type == CWIDatas.WidIDtype.ACe)
                {
                    basename = "Item";
                    tempname = "Item";
                }
                else if(type == CWIDatas.WidIDtype.XL)
                {
                    basename = "Skill";
                    tempname = "Skill";

                } else if(type == CWIDatas.WidIDtype.b)
                {
                    basename = "Beast";
                    tempname = "Beast";

                } else {
                    PartyMaker.CWIErrorMessage("肦ȂJ[hʂłB");
                }
            }

            while (File.Exists(innFolder + "\\" + tempname + ExtWidData))
            {
                num++;
                tempname = basename + "(" + num.ToString() + ")";
            }
            return innFolder + "\\" + tempname + ExtWidData;
        }
        #endregion

        #region t@CEtH_i폜֘Aj
        /// <summary>
        /// tH_폜
        /// </summary>
        /// <param name="folderPath">pX</param>
        public static void DeleteFolder(string folderPath)
        {
            try
            {
                // tH_ƒg폜
                if (Directory.Exists(folderPath))
                {
                    // ɂꍇ͍폜
                    Directory.Delete(folderPath, true);
                }
            }
            catch //(Exception ex)
            {
                //PartyMaker.CWIErrorMessage("tH_̍폜Ɏs܂B" + ex.Message);
            }
        }

        /// <summary>
        /// tH_쐬
        /// </summary>
        /// <param name="folderPath">pX</param>
        public static void CreateFolder(string folderPath)
        {
            DeleteFolder(folderPath);
            Directory.CreateDirectory(folderPath);
        }

        /// <summary>
        /// t@C폜
        /// </summary>
        /// <param name="filePath">pX</param>
        public static void DeleteFile(string filePath)
        {
            try
            {
                // t@C폜
                if (File.Exists(filePath))
                {
                    File.Delete(filePath);
                }
            }
            catch (Exception ex)
            {
                PartyMaker.CWIErrorMessage("t@C̍폜Ɏs܂B" + ex.Message);
            }
        }

        /// <summary>
        /// ֑܂܂Ă邩ǂ̃`FbN
        /// </summary>
        /// <param name="cardName"></param>
        /// <returns></returns>
        public static bool isProhibition(string cardName)
        {
            if(Regex.IsMatch(cardName,@".*[\.\/\\\:\*\?\""\<\>\|\\].*"))
            {
                return true;
            } else {
                return false;
            }
        }
        #endregion
    
    }


}
