
using System;
using System.Drawing;
using System.Resources;
using System.Collections.Generic;
using System.Collections.Specialized;
using CWIDatas;

namespace CWI
{
    /// <summary>
    /// Description of Util1.
    /// </summary>
    public class Util1
    {
        #region static
        public static String MoneyUnit = " sp  ";
        //̑
        public static readonly string[] CouponEnumerateStr = { "QP", "QQ", "QR", "QS", "QT", "QU" };
        public static readonly string[] CouponEnumerateOld = { "OP", "OQ", "OR", "OS", "OT", "OU" };
        #endregion

        #region Z[uf[^
        /// <summary>
        /// p[eB[f[^Z[uɕKvȃp[eB[CfbNXf[^܂
        /// </summary>
        /// <param name="inn">hf[^</param>
        /// <param name="pd">p[eB[f[^</param>
        /// <returns>Vɍꂽp[eBCfbNXf[^</returns>
        public static PartyIndexData MakePartyIndexData(InnData inn,PartyData pd)
        {
            PartyIndexData pid = new PartyIndexData();

            pid.InScenario = pd.InScenario;

            pid.Money = pd.Money;
            pid.PartyName = pd.PartyName;

            if (pid.InScenario)
            {
                pid.PlayingScenarioName = pd.Summary.ScenarioName;
                pid.ScenarioImage = pd.Summary.Image;
            }
            else
            {
                pid.PlayingScenarioName = inn.Name;
                pid.ScenarioImage = new ImageData();

                if (inn.IsDebugInn)
                    pid.ScenarioImage = new ImageData(CWIEngine.Properties.Resources.CardMenu_foOh);
                else
                    pid.ScenarioImage = new ImageData(CWIEngine.Properties.Resources.CardMenu_Ŕ);
            }

            foreach (CharacterData cd in pd.Characters)
            {
                pid.Members.Add(cd.CardName);
            }

            return pid;
        }
        /// <summary>
        /// LN^[f[^Z[uɕKvȃLN^[hҋ@CfbNXf[^܂
        /// </summary>
        /// <param name="cd">f[^ƂȂLN^[</param>
        /// <returns>Z[up̃CfbNXLf[^</returns>
        public static IndexCharacterData MakeCharacterIndexData(CharacterData cd)
        {
            IndexCharacterData icd = new IndexCharacterData();
            icd.Name = cd.CardName;
            icd.Image = cd.Image;
            icd.Level = cd.Level;
            StringCollection coupons = icd.Coupons;
            // EPIndexCharacterDatał̓N[|ƐlŗĂBCharacterDatał̓N[|B
            icd.EP = 0;
            foreach (CouponData coup in cd.Coupons)
            {
                if (coup.Name == CWData.STR_EP)
                {
                    icd.EP = coup.Point;
                }
                coupons.Add(coup.Name);
            }
            icd.Dex = cd.Dex;
            icd.Agl = cd.Agl;
            icd.Int = cd.Int;
            icd.Str = cd.Str;
            icd.Vit = cd.Vit;
            icd.Min = cd.Min;
            return icd;
        }
        #endregion

        #region tOAXebv
        /// <summary>
        /// BorlandStringList`ɂ"=l"̒l𕶎ƂĕԂ[`
        /// </summary>
        /// <param name="data"></param>
        /// <returns>l̕</returns>
        public static string ValueOfStrings(string data)
        {
            return data.Substring(data.LastIndexOf('=') + 1);
        }
        #endregion

        #region N[|

        /// <summary>
        /// N[|̍v_ő僌xvZ
        /// Level n ɕKvȓ_ n(n-1)
        /// Level n+1 ɕKvȓ_ n(n+1)
        /// </summary>
        /// <param name="cd">TL</param>
        /// <returns></returns>
        public static uint GetMaxLevel(CharacterData cd)
        {
            int coupSum = 0;

            bool maxFlag = false;
            uint levelMax = 0;

            foreach (CouponData coup in cd.Coupons)
            {
                if (coup.Name.StartsWith("F")
                    || coup.Name.StartsWith("G")
                    || coup.Name.StartsWith("O")
                   )
                {
                    continue;
                }
                else if (coup.Name.StartsWith(""))
                {
                    if (coup.Name.Equals(CWData.STR_LEVEL_BASE))
                    {
                        // x_Ɛݒ肳Ă炱ꂪ݂̍őLV
                        return (uint)coup.Point;
                    }
                    else if (coup.Name.Equals(CWData.STR_LEVEL_MAX))
                    {
                        // xݒ肳ĂƂ肠Ă
                        maxFlag = true;
                        levelMax = (uint)coup.Point;
                        continue;
                    }
                    else
                    {
                        continue;
                    }
                }
                coupSum += coup.Point;
            }

            uint level = 1;
            while (level * (level + 1) <= coupSum)
            {
                level++;
            }

            if (maxFlag)
            {
                // xݒ肳Ă
                return (level > levelMax) ? levelMax : level;
            }
            else
            {
                // xݒ肳ĂȂ
                return level;
            }
        }

        /// <summary>
        /// x
        /// Level n ɕKvȓ_ n(n-1)
        /// Level n+1 ɕKvȓ_ n(n+1)
        /// </summary>
        /// <param name="cd">TL</param>
        /// <returns></returns>
        public static LevelInfo GetLevelInfo(CharacterData cd)
        {
            LevelInfo info = new LevelInfo();

            int coupSum = 0;

            bool maxFlag = false;
            uint levelMax = 0;
            uint levelBase = 0;

            foreach (CouponData coup in cd.Coupons)
            {
                if (coup.Name.StartsWith("F")
                    || coup.Name.StartsWith("G")
                    || coup.Name.StartsWith("O")
                   )
                {
                    continue;
                }
                else if (coup.Name.StartsWith(""))
                {
                    if (coup.Name.Equals(CWData.STR_LEVEL_BASE))
                    {
                        // x_Ɛݒ肳Ă炱ꂪ݂̍őLV
                        levelBase = (uint)coup.Point; 
                        continue;
                    }
                    else if (coup.Name.Equals(CWData.STR_LEVEL_MAX))
                    {
                        // xݒ肳ĂƂ肠Ă
                        maxFlag = true;
                        levelMax = (uint)coup.Point;
                        continue;
                    }
                    else
                    {
                        continue;
                    }
                }
                coupSum += coup.Point;
            }

            uint level = 1;
            while (level * (level + 1) <= coupSum)
            {
                level++;
            }

            if (maxFlag)
            {
                // xݒ肳Ă
                if(level >= levelMax) 
                {
                    info.Exp = (int)(levelMax * (levelMax - 1));
                    info.MaxLv = levelMax;
                    info.Next = 0;
                } else {
                    info.Exp = coupSum;
                    info.MaxLv = level;
                    info.Next = level * (level + 1);
                }
            }
            else
            {
                // xݒ肳ĂȂ
                info.Exp = coupSum;
                info.MaxLv = level;
                info.Next = level * (level + 1);
            }

            return info;
        }

        /// <summary>
        /// p[eB[SɃN[|zz܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="name">zzN[|</param>
        /// <param name="point">N[|_</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static void SetCouponAll(PartyData pd, string name, int point)
        {
            foreach (CharacterData chara in pd.Characters)
            {
                chara.SetCoupon(name, point);
            }
        }

        /// <summary>
        /// p[eB[̎N[|namẽN[|f[^T܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="name">TN[|</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static bool CheckCoupon(PartyData pd, string name)
        {
            foreach (CharacterData chara in pd.Characters)
            {
                if (chara.CheckCoupon(name) == true)
                    return true;
            }

            return false;
        }

        /// <summary>
        /// p[eB[̎N[|namẽN[|f[^T܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="name">TN[|</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static bool CheckCouponAll(PartyData pd, string name)
        {
            foreach (CharacterData chara in pd.Characters)
            {
                if (chara.CheckCoupon(name) == true)
                {
                    continue;
                }
                
                return false;
            }

            return true;
        }
        /// <summary>
        /// p[eB[̎N[|namẽN[|f[^폜܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="name">폜N[|</param>
        public static void RemoveCouponAll(PartyData pd, string name)
        {
            foreach (CharacterData chara in pd.Characters)
            {
                chara.RemoveCoupon(name);
            }
        }

        /// <summary>
        /// p[eB[XLĂ邩ǂ`FbN܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="name">TXL</param>
        /// <param name="expression">TXL̉</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static bool CheckSkill(PartyData pd, string name
            , string expression)
        {
            foreach (CharacterData chara in pd.Characters)
            {
                foreach (WidCard wc in chara.Skills)
                {
                    if (wc.CardName == name && wc.Expression == expression)
                        return true;
                }
            }

            return false;
        }
        /// <summary>
        /// p[eB[ACeĂ邩ǂ`FbN܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="name">TXL</param>
        /// <param name="expression">TXL̉</param>
        /// <returns>炻̃LindexBȂ-1Ԃ</returns>
        public static int CheckItem(PartyData pd, string name
            , string expression)
        {
            for(int index = 0;index < pd.Characters.Count; index++)
            {
                CharacterData chara = pd.Characters[index];
                foreach (WidCard wc in chara.Items)
                {
                    if (wc.CardName == name && wc.Expression == expression)
                        return index;
                }
            }

            return -1;
        }
        /// <summary>
        /// ו܂܂߂
        /// p[eB[XLĂ邩ǂ`FbN܂B
        /// </summary>
        /// <param name="inn">Ώۏh</param>
        /// <param name="name">TXL</param>
        /// <param name="expression">TXL̉</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static bool CheckSkillAll(InnData inn, string name 
            ,string expression)
        {
            return CheckCardAll(inn, CardIndexData.Kind.skill,
                                name, expression);
        }

        /// <summary>
        /// ו܂܂߂
        /// p[eB[ACeĂ邩ǂ`FbN܂B
        /// </summary>
        /// <param name="inn">Ώۏh</param>
        /// <param name="name">TACe</param>
        /// <param name="expression">TACẻ</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static bool CheckItemAll(InnData inn, string name
            , string expression)
        {
            return CheckCardAll(inn, CardIndexData.Kind.item, 
                                name, expression);
        }

        private static bool CheckCardAll(InnData inn
            , CardIndexData.Kind kind
            , string name
            , string expression)
        {
            PartyData pd = inn.CurrentParty;

            List<WidCard> list = null;


            foreach (CharacterData chara in pd.Characters)
            {            
                switch (kind)
                {
                    case CardIndexData.Kind.skill:
                        list = chara.Skills;
                        break;
                    case CardIndexData.Kind.item:
                        list = chara.Items;
                        break;
                    case CardIndexData.Kind.beast:
                        list = chara.Beasts;
                        break;
                    default:
                        return false;
                }

                foreach (WidCard wc in list)
                {
                    if (wc.CardName == name && wc.Expression == expression)
                        return true;
                }
            }

            foreach (RenamedCardData rcd in pd.BagCards)
            {
                IndexCardData icd = inn.FindIndexedCardData(rcd);
                if (icd.Index >= 0
                    && icd.CardData.CardKind == kind
                    && icd.CardData.Name == name
                    && icd.CardData.Expression == expression)
                    return true;
            }

            return false;
        }

        /// <summary>
        /// Jgp[eB[PCwJ[hꖇ폜
        /// </summary>
        /// <param name="inn"></param>
        /// <param name="kind"></param>
        /// <param name="name"></param>
        /// <param name="expression"></param>
        /// <returns></returns>
        public static bool DeleteCardOne(InnData inn
            , CardIndexData.Kind kind
            , string name
            , string expression)
        {
            PartyData pd = inn.CurrentParty;

            List<WidCard> list = null;

            foreach (CharacterData chara in pd.Characters)
            {
                switch (kind)
                {
                    case CardIndexData.Kind.skill:
                        list = chara.Skills;
                        break;
                    case CardIndexData.Kind.item:
                        list = chara.Items;
                        break;
                    case CardIndexData.Kind.beast:
                        list = chara.Beasts;
                        break;
                    default:
                        return false;
                }

                foreach (WidCard wc in list)
                {
                    if (wc.CardName == name && wc.Expression == expression)
                    {
                        // ̂ō폜ɓ܂B
                        list.Remove(wc);

                        return true;
                    }
                }
            }

            foreach (RenamedCardData rcd in pd.BagCards)
            {
                IndexCardData icd = inn.FindIndexedCardData(rcd);
                if (icd.Index >= 0
                    && icd.CardData.CardKind == kind
                    && icd.CardData.Name == name
                    && icd.CardData.Expression == expression)
                {
                    // ̂ō폜ɓ܂B
                    inn.DeleteRenamedCardData(pd.BagCards, rcd);

                    return true;
                }
            }

            return false;
        }

        /// <summary>
        /// p[eB[̕σxw背xȏォǂ`FbN܂B
        /// </summary>
        /// <param name="pd">Ώۃp[eB[</param>
        /// <param name="lv">w背x</param>
        /// <returns>trueBȂfalseԂ</returns>
        public static bool CheckPartyLevel(PartyData pd, decimal lv)
        {
            if (pd.Characters.Count == 0) return false;
            decimal sum = 0;
            foreach (CharacterData chara in pd.Characters)
            {
                sum += chara.Level;
            }

            sum = sum / pd.Characters.Count;

            return sum >= lv;
        }

        #endregion

        #region Cxgf[^
        public static readonly int EventFire_Click = 1;
        public static readonly int EventFire_Arrive = 1;
        public static readonly int EventFire_Win = 1;
        public static readonly int EventFire_Escape = 2;
        public static readonly int EventFire_Lose = 3;
        public static readonly int EventFire_EnemyDeath = 1;

        /// <summary>
        /// eventlistsystenmNumberɑΉCxgԂBȂnullԂB
        /// </summary>
        /// <param name="eventlist">CxgXg</param>
        /// <param name="systemNumber">ToCxg̎ޔԍ</param>
        /// <returns>YCxgf[^or null</returns>
        public static EventData GetEvent(List<EventData> eventlist, int systemNumber)
        {
            foreach (EventData ev in eventlist)
            {
                if (ev.SystemFireNumbers != null)
                {
                    foreach (int num in ev.SystemFireNumbers)
                    {
                        if (systemNumber == num)
                            return ev;
                    }
                }
            }
            return null;
        }

        /// <summary>
        /// eventlistusingCardJ[h̎gpŔ΂L[R[hCxgԂBȂnullԂB
        /// </summary>
        /// <param name="eventlist">CxgXg</param>
        /// <param name="usingCard">KpJ[hf[^</param>
        /// <returns>΂Cxgf[^ or null</returns>
        public static EventData GetKeycodeEvent(List<EventData> eventlist, WidCard usingCard)
        {
            foreach (EventData ev in eventlist)
            {
                foreach (string evKey in ev.KeyCodes)
                {
                    //J[hƏƍ
                    if (evKey == usingCard.CardName)
                        return ev;
                    //L[R[hƏƍ
                    foreach (string cardKey in usingCard.KeyCode)
                    {

                        if (cardKey != null &&
                            cardKey == evKey)
                            return ev;
                    }
                }
            }
            return null;
        }

        /// <summary>
        /// eventlist̒cardgɔ΂L[R[hCxgԂBȂnullԂ
        /// </summary>
        /// <param name="eventlist">CxgXg</param>
        /// <param name="card">gpJ[h</param>
        /// <returns>΂L[R[hCxg</returns>
        public static EventData GetKeyCodeEvent(List<EventData> eventlist, WidCard card)
        {
            foreach (EventData ev in eventlist)
            {
                foreach (string key in ev.KeyCodes)
                {
                    if (key == card.CardName)
                        return ev;
                    foreach (string cardKey in card.KeyCode)
                    {
                        if (cardKey != null && cardKey == key)
                            return ev;
                    }
                }
            }
            return null;
        }
        #endregion

        #region [eBeB
        /// <summary>
        /// ㉺͈͎w
        /// </summary>
        /// <param name="physParam"></param>
        /// <param name="minValue"></param>
        /// <param name="MaxValue"></param>
        /// <returns></returns>
        public static int NumWrap(int physParam, int minValue, int MaxValue)
        {
            if (physParam < minValue)
                physParam = minValue;
            if (physParam > MaxValue)
                physParam = MaxValue;
            return physParam;
        }

        /// <summary>
        /// ㉺͈͎w(_I)
        /// </summary>
        /// <param name="mindParam"></param>
        /// <param name="minValue"></param>
        /// <param name="MaxValue"></param>
        /// <returns></returns>
        public static int NumWrap(double mindParam, int minValue, int MaxValue)
        {
            int mindParamInt = (int)mindParam;
            if (mindParamInt < minValue)
                mindParamInt = minValue;
            if (mindParamInt > MaxValue)
                mindParamInt = MaxValue;
            return mindParamInt;
        }

        /// <summary>
        /// ]
        /// </summary>
        /// <param name="old"></param>
        /// <returns></returns>
        public static string StringReverse(string old)
        {
            string ret = string.Empty;
            for (int i = old.Length - 1; i >= 0; i--)
            {
                ret += old[i];
            }
            return ret;
        }

        #endregion

    }//class

    public class LevelInfo
    {
        private int exp = 0;
        private uint maxLv = 0;
        private uint _next = 0;

        public int Exp
        {
            get { return exp; }
            set { exp = value; } 
        }

        public uint MaxLv
        {
            get { return maxLv; }
            set { maxLv = value; }
        }
        public uint Next 
        { 
            get { return _next; } 
            set{ _next = value; }
        }

    }
}//namespace
