
using System;
using System.IO;
using System.Drawing;
using System.Collections.Generic;
using CWI.Card;
using CWIDatas;


namespace CWI
{
    public static class Util3
    {
        /// <summary>
        /// KɑΉp[^Ɣ\͏C̑vlԂ
        /// </summary>
        /// <param name="target">p[^oLN^[</param>
        /// <param name="body">g̓Ivf</param>
        /// <param name="mind">_Ivf</param>
        /// <returns>{[iXl̑vl</returns>
        public static int GetCharacterPower(CharacterData target, g̓Ivf bodyFactor, _Ivf mindFactor)
        {
            int bless;
            bless = target.MagicPowerBonus;

            return GetCharacterPower(target, bodyFactor, mindFactor, bless);
        }

        /// <summary>
        /// KɑΉp[^Ɣ\͏C̑vlԂB
        /// s͏CœnŁB
        /// </summary>
        /// <param name="target">p[^oLN^[</param>
        /// <param name="body">g̓Ivf</param>
        /// <param name="mind">_Ivf</param>
        /// <param name="bless">s͏C</param>
        /// <returns>{[iXl̑vl</returns>
        public static int GetCharacterPower(CharacterData target,
                                            g̓Ivf bodyFactor,
                                            _Ivf mindFactor,
                                            int bless)
        {
            int body, mind;
            switch (bodyFactor)
            {
                case g̓Ivf.px:
                    body = target.Dex;
                    break;
                case g̓Ivf.q:
                    body = target.Agl;
                    break;
                case g̓Ivf.m:
                    body = target.Int;
                    break;
                case g̓Ivf.ؗ:
                    body = target.Str;
                    break;
                case g̓Ivf.:
                    body = target.Vit;
                    break;
                case g̓Ivf._:
                    body = target.Min;
                    break;
                default:
                    body = 0;
                    break;
            }
            switch (mindFactor)
            {
                case _Ivf.:
                    mind = -target.Trickish;
                    break;
                case _Ivf._:
                    mind = -target.Cautious;
                    break;
                case _Ivf.a:
                    mind = -target.Brave;
                    break;
                case _Ivf.:
                    mind = -target.Cheerful;
                    break;
                case _Ivf.a:
                    mind = -target.Aggressive;
                    break;
                case _Ivf.D퐫:
                    mind = target.Aggressive;
                    break;
                case _Ivf.Ќ:
                    mind = target.Cheerful;
                    break;
                case _Ivf.EҐ:
                    mind = target.Brave;
                    break;
                case _Ivf.Td:
                    mind = target.Cautious;
                    break;
                case _Ivf.ϐ:
                    mind = target.Trickish;
                    break;
                default:
                    mind = -10;
                    break;
            }

            return body + mind + bless;
        }

        /// <summary>
        /// ԔReg̔
        /// </summary>
        /// <param name="target"></param>
        /// <param name="checkByte">ށiRegł̒lj</param>
        /// <returns>萬true</returns>
        public static bool StatusCheck(CharacterData target, byte checkByte)
        {
            switch (checkByte)
            {
                case 0:  //s\
                    return target.IsMovable;
                case 1:  //ss
                    return !target.IsMovable;
                case 2:  //
                    return target.IsLive;
                case 3:  //񐶑
                    return !target.IsLive;
                case 4:  //N
                    return target.HitPoint == target.MaxHitPoint;
                case 5:  //
                    return target.HitPoint < target.MaxHitPoint;
                case 6:  //d
                    return target.HitPoint < target.MaxHitPoint / 5;
                case 7:  //ӎs
                    return target.HitPoint == 0;
                case 8:  //
                    return target.Poison > 0;
                case 9:  //
                    return target.IsSleep;
                case 10: //
                    return target.BindRound > 0;
                case 11: //აΉ
                    return target.Paralyse > 0;
                default:
                    return false;
            }
        }

        /// <summary>
        /// rbg}bvC
        /// </summary>
        /// <param name="fullpath"></param>
        public static void FixBitmap(string fullpath)
        {
            // PNGEGIF̏ꍇ͏Ȃ
            if (!fullpath.EndsWith(FilePath.ExtBitmap)) return;

            //CBitmap̃tpXĂB
            byte[] reads = File.ReadAllBytes(fullpath);
            
            int size = reads.Length;
            if (size < 2) return;
            byte[] writes = new byte[size];

            if (reads[0] != 0x42 || reads[1] != 0x4d)
            {
                //BMŎn܂ĂȂIigbmpł͂Ȃj
                reads = null;
                Bitmap bmp = new Bitmap(fullpath);
                string tempfile = "temp_"
              + DateTime.Now.ToString("yyyyMMdd_HHmmss_fff")
              + ".bmp";

                // rbg}bvŃZ[uȂ
                bmp.Save(tempfile, System.Drawing.Imaging.ImageFormat.Bmp);

                bmp.Dispose();

                File.Copy(tempfile, fullpath, true);

                reads = File.ReadAllBytes(fullpath);

                writes = new byte[reads.Length];

                File.Delete(tempfile);
            }

            reads.CopyTo(writes, 0);

            ulong biSizeImage = (ulong)reads[0x22] + (ulong)(reads[0x23] << 8)
            + (ulong)(reads[0x24] << 16) + (ulong)(reads[0x25] << 24);

            if (biSizeImage == 0)
            {
                // Bitmap.Save BmpȊOBitmapNX쐬ĂꍇBmp`Saveꍇ
                // biSizeImage 0 ɂȂ邱ƂB

                ulong fileSize = (ulong)reads[0x02] + (ulong)(reads[0x03] << 8)
                + (ulong)(reads[0x04] << 16) + (ulong)(reads[0x05] << 24);

                ulong trueHeaderSize = (ulong)reads[0x0a] + (ulong)(reads[0x0b] << 8)
                + (ulong)(reads[0x0c] << 16) + (ulong)(reads[0x0d] << 24);

                ulong biSizeImageNew = fileSize - trueHeaderSize;

                writes[0x25] = (byte)(biSizeImageNew / (ulong)(1 << 24));
                writes[0x24] = (byte)((biSizeImageNew % (ulong)(1 << 24)) / (ulong)(1 << 16));
                writes[0x23] = (byte)((biSizeImageNew % (ulong)(1 << 16)) / (ulong)(1 << 8));
                writes[0x22] = (byte)(biSizeImageNew % (ulong)(1 << 8));

                File.Delete(fullpath);

                File.WriteAllBytes(fullpath, writes);
            }

        }

        /// <summary>
        /// CardIndexDataKind𕶎ɕϊ
        /// </summary>
        /// <param name="kind"></param>
        /// <returns></returns>
        public static string KindToText(CardIndexData.Kind kind)
        {
            string text = string.Empty;
            switch (kind)
            {
                case CardIndexData.Kind.skill:
                    text = CWData.SKILL;
                    break;
                case CardIndexData.Kind.item:
                    text = CWData.ITEM;
                    break;
                case CardIndexData.Kind.beast:
                    text = CWData.BEAST;
                    break;
            }
            return text;
        }
        
        #region ʎs
        public static readonly int EffectContentBonus = 8;

        /// <summary>
        /// ʂ邩`FbNB
        /// </summary>
        /// <param name="target"></param>
        /// <param name="effects"></param>
        /// <param name="level"></param>
        /// <param name="bonus"></param>
        /// <param name="cardAttribute"></param>
        /// <param name="resistAttribute"></param>
        /// <param name="SucceedBonus"></param>
        /// <param name="user"></param>
        /// <param name="soundOnEffect"></param>
        /// <param name="visualEffect"></param>
        public static bool CheckValidEffects(CharacterData target, List<EffectData> effects,
            int level, int bonus, ʑ cardAttribute, R resistAttribute, int SucceedBonus,
            CharacterData user, String soundOnEffect, o visualEffect)
        {
            //TODO 
            return true;
        }

        /// <summary>
        /// ӎs҂ɑ΂āAʂ̂GtFNgĂ邩𔻒肷B
        /// </summary>
        /// <param name="effects">肷GtFNgQ</param>
        /// <returns>ʂGtFNg܂łꍇtrue</returns>
        public static bool CheckValidToDead(List<EffectData> effects)
        {
            foreach (EffectData ef in effects)
            {
                if (ef.EffectTab == EffectData.ʃ^u. &&
                    ef.EffectNumberInTab == 0) //񕜂͈ӎsłL
                    return true;
                if (ef.EffectTab == EffectData.ʃ^u.) //łƖჂ͗L
                    return true;
                if (ef.EffectTab == EffectData.ʃ^u.Z\) //_͌ʂ͗L
                    return true;
                if (ef.EffectTab == EffectData.ʃ^u. &&
                    ef.EffectNumberInTab == 0) //Ώۏ͗L
                    return true;
            }
            return false;
        }


        private enum \͏C
        {
            h, , R, s
        }

        /// <summary>
        /// LSẴXL̎gp񐔂őlɉ񕜂
        /// </summary>
        /// <param name="target">񕜂LN^[</param>
        public static void SetAllSkillRecover(CharacterData target)
        {
            foreach (WidCard wc in target.Skills)
            {
                wc.SkillRemainUseCount = GameParam.GetMaxSkillUseCount(target.Level, wc.Level);
            }
        }

        /// <summary>
        /// LSẴXL̎gp񐔂Oɂ
        /// </summary>
        /// <param name="target">s\ɂLN^[</param>
        private static void SetAllSkillUnuse(CharacterData target)
        {
            foreach (WidCard wc in target.Skills)
            {
                wc.SkillRemainUseCount = 0;
            }
        }

        /// <summary>
        /// 퓬s\ԂɂȂɑ̏Ԉُł
        /// </summary>
        /// <param name="target">퓬s\ɂȂLN^[</param>
        private static void SetStateDeath(CharacterData target)
        {
            SetStateParalyze(target);
        }

        /// <summary>
        /// ჏ԂɂȂɑ̏Ԉُł
        /// </summary>
        /// <param name="target">ჂLN^[</param>
        private static void SetStateParalyze(CharacterData target)
        {
            //@ʏ
            target.BindRound = 0;
            target.DiscloseRound = 0;
            target.SilentRound = 0;
            target.InvalidateMagicRound = 0;
            //\͒lύX@
            target.MagicArmorBonus = 0;
            target.MagicArmorRound = 0;
            target.MagicAvoidBonus = 0;
            target.MagicAvoidRound = 0;
            target.MagicPowerBonus = 0;
            target.MagicPowerRound = 0;
            target.MagicResistBonus = 0;
            target.MagicResistRound = 0;
            //_ُ
            target.MindStates = CharacterData.StateMind.;
            target.MindRound = 0;
            // b
            VanishBeasts(target);
        }

        /// <summary>
        /// ɂ鏢bSď
        /// </summary>
        /// <param name="target">bLN^[</param>
        private static void VanishBeasts(CharacterData target)
        {
            int i = 0;
            while (i < target.Beasts.Count)
            {
                if (target.Beasts[i].HutaiBeast)
                    i++;
                else
                    target.Beasts.RemoveAt(i);
            }
        }

        /// <summary>
        /// kindŎw肵ނ̔\͒lCb̎gp񐔂PB
        /// OɂȂb͏łB
        /// </summary>
        /// <param name="target">bՂLN^[</param>
        /// <param name="kind">C|\͒l̎</param>
        private static void ConsumeBeastBonus(CharacterData target, \͏C kind)
        {
            int i = 0;
            while (i < target.Beasts.Count)
            {
                WidCard beast = target.Beasts[i];
                if (beast.HutaiBeast ||
                    (kind == \͏C. && beast.AvoidModifyUsing == 0) ||
                    (kind == \͏C.R && beast.ResistModifyUsing == 0) ||
                    (kind == \͏C.h && beast.ArmorModifyUsing == 0))
                    i++;
                else
                {
                    beast.ItemRemainUseCount--;
                    if (beast.ItemRemainUseCount == 0)
                        target.Beasts.RemoveAt(i);
                    else
                        i++;
                }
            }
        }

        #endregion

        #region ViIf[^ҏW

        public static void SetInitScenarioData(ScenarioData scena, SummaryData summary)
        {
            // ViI̊JnGAԍݒ
            scena.AreaNumber = summary.AreaNumber;

            // Xebv
            foreach (StepIndexData sid in summary.Steps)
            {
                scena.StepValues.Add(sid.StepName + "=" + sid.InitialValue);
            }

            // tO
            foreach (FlagIndexData fid in summary.Flags)
            {
                scena.StepValues.Add(fid.FlagName + "=" + fid.InitialValue);
            }
        }

        public static void SetAreaInitCell(ScenarioData scena,
            string scenaFolder, uint areaNo)
        {
            scena.AreaNumber = areaNo;

            try
            {
                WidArea area = new WidArea();
                
                area.Read(scenaFolder + "\\Area" + areaNo + ".wid");

                scena.Cells.Clear();
                scena.Cells.AddRange(area.Cells);

                area = null;
                
            }
            catch (Exception ex)
            {
                PartyMaker.CWIErrorMessage("GA̓ǂݍ݂Ɏs܂B:" + ex.ToString());
            }
        }
        #endregion

    }//class
}
