﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

using CWI.Dialog;
using CWIDatas;
using CWI.Card;

namespace CWI
{
    public partial class WidDispCard : UserControl
    {
        public WidCard wc;

        public WidDispCard()
        {
            InitializeComponent();
        }

        public WidDispCard(WidCard wc)
        {
            InitializeComponent();

            SetWc(wc);
        }

        public void SetWc(WidCard wc)
        {
            this.wc = wc;

            // カーソルがあたったときに赤色表示
            // クリックされたらダイアログ表示の実装が必要
            this.Invalidate();
        }

        private void WidDispCard_MouseEnter(object sender, EventArgs e)
        {
            this.ForeColor = Color.Red;
            this.Invalidate();
        }

        private void WidDispCard_MouseLeave(object sender, EventArgs e)
        {
            this.ForeColor = Color.White;
            this.Invalidate();
        }

        private void WidDispCard_Paint(object sender, PaintEventArgs e)
        {
            using (Graphics g = e.Graphics)
            using (SolidBrush brush = new SolidBrush(this.ForeColor))
            {
                g.DrawString(wc.CardName, this.Font, brush, new Point(20, 1));
            }
        }

    }
}
